/* A Bison parser, made by GNU Bison 3.0.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "parse.y" /* yacc.c:339  */

// See the file "COPYING" in the main distribution directory for copyright.
#line 77 "parse.y" /* yacc.c:339  */

#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include "input.h"
#include "Expr.h"
#include "Stmt.h"
#include "Var.h"
/* #include "analyzer/protocol/dns/DNS.h" */
#include "RE.h"
#include "Scope.h"
#include "Reporter.h"
#include "Brofiler.h"
#include "broxygen/Manager.h"

#include <set>
#include <string>

extern const char* filename;  // Absolute path of file currently being parsed.

YYLTYPE GetCurrentLocation();
extern int yyerror(const char[]);
extern int brolex();

#define YYLLOC_DEFAULT(Current, Rhs, N) \
	(Current) = (Rhs)[(N)];

/*
 * Part of the module facility: while parsing, keep track of which
 * module to put things in.
 */
string current_module = GLOBAL_MODULE_NAME;
bool is_export = false; // true if in an export {} block

/*
 * When parsing an expression for the debugger, where to put the result
 * (obviously not reentrant).
 */
extern Expr* g_curr_debug_expr;
extern bool in_debug;
extern const char* g_curr_debug_error;

#define YYLTYPE yyltype

static int in_hook = 0;
int in_init = 0;
int in_record = 0;
bool resolving_global_ID = false;
bool defining_global_ID = false;
std::vector<int> saved_in_init;

ID* func_id = 0;
EnumType *cur_enum_type = 0;
static ID* cur_decl_type_id = 0;

static void parser_new_enum (void)
	{
	/* Starting a new enum definition. */
	assert(cur_enum_type == NULL);

	if ( cur_decl_type_id )
		cur_enum_type = new EnumType(cur_decl_type_id->Name());
	else
		reporter->FatalError("incorrect syntax for enum type declaration");
	}

static void parser_redef_enum (ID *id)
	{
	/* Redef an enum. id points to the enum to be redefined.
	   Let cur_enum_type point to it. */
	assert(cur_enum_type == NULL);
	if ( ! id->Type() )
		id->Error("unknown identifier");
	else
		{
		cur_enum_type = id->Type()->AsEnumType();
		if ( ! cur_enum_type )
			id->Error("not an enum");
		}
	}

static type_decl_list* copy_type_decl_list(type_decl_list* tdl)
	{
	if ( ! tdl )
		return 0;

	type_decl_list* rval = new type_decl_list();

	loop_over_list(*tdl, i)
		{
		TypeDecl* td = (*tdl)[i];
		rval->append(new TypeDecl(*td));
		}

	return rval;
	}

static attr_list* copy_attr_list(attr_list* al)
	{
	if ( ! al )
		return 0;

	attr_list* rval = new attr_list();

	loop_over_list(*al, i)
		{
		Attr* a = (*al)[i];
		::Ref(a);
		rval->append(a);
		}

	return rval;
	}

static void extend_record(ID* id, type_decl_list* fields, attr_list* attrs)
	{
	set<BroType*> types = BroType::GetAliases(id->Name());

	if ( types.empty() )
		{
		id->Error("failed to redef record: no types found in alias map");
		return;
		}

	for ( set<BroType*>::const_iterator it = types.begin(); it != types.end(); )
		{
		RecordType* add_to = (*it)->AsRecordType();
		const char* error = 0;
		++it;

		if ( it == types.end() )
			error = add_to->AddFields(fields, attrs);
		else
			error = add_to->AddFields(copy_type_decl_list(fields),
			                          copy_attr_list(attrs));

		if ( error )
			{
			id->Error(error);
			break;
			}
		}
	}

static bool expr_is_table_type_name(const Expr* expr)
	{
	if ( expr->Tag() != EXPR_NAME )
		return false;

	BroType* type = expr->Type();

	if ( type->IsTable() )
		return true;

	if ( type->Tag() == TYPE_TYPE )
		return type->AsTypeType()->Type()->IsTable();

	return false;
	}

#line 231 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "broparse.h".  */
#ifndef YY_YY_USR_SRC_RPM_BUILD_BRO_2_6_BUILD_SRC_BROPARSE_H_INCLUDED
# define YY_YY_USR_SRC_RPM_BUILD_BRO_2_6_BUILD_SRC_BROPARSE_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_ADD = 258,
    TOK_ADD_TO = 259,
    TOK_ADDR = 260,
    TOK_ANY = 261,
    TOK_ATENDIF = 262,
    TOK_ATELSE = 263,
    TOK_ATIF = 264,
    TOK_ATIFDEF = 265,
    TOK_ATIFNDEF = 266,
    TOK_BOOL = 267,
    TOK_BREAK = 268,
    TOK_CASE = 269,
    TOK_OPTION = 270,
    TOK_CONST = 271,
    TOK_CONSTANT = 272,
    TOK_COPY = 273,
    TOK_COUNT = 274,
    TOK_COUNTER = 275,
    TOK_DEFAULT = 276,
    TOK_DELETE = 277,
    TOK_DOUBLE = 278,
    TOK_ELSE = 279,
    TOK_ENUM = 280,
    TOK_EVENT = 281,
    TOK_EXPORT = 282,
    TOK_FALLTHROUGH = 283,
    TOK_FILE = 284,
    TOK_FOR = 285,
    TOK_FUNCTION = 286,
    TOK_GLOBAL = 287,
    TOK_HOOK = 288,
    TOK_ID = 289,
    TOK_IF = 290,
    TOK_INT = 291,
    TOK_INTERVAL = 292,
    TOK_LIST = 293,
    TOK_LOCAL = 294,
    TOK_MODULE = 295,
    TOK_NEXT = 296,
    TOK_OF = 297,
    TOK_OPAQUE = 298,
    TOK_PATTERN = 299,
    TOK_PATTERN_END = 300,
    TOK_PATTERN_TEXT = 301,
    TOK_PORT = 302,
    TOK_PRINT = 303,
    TOK_RECORD = 304,
    TOK_REDEF = 305,
    TOK_REMOVE_FROM = 306,
    TOK_RETURN = 307,
    TOK_SCHEDULE = 308,
    TOK_SET = 309,
    TOK_STRING = 310,
    TOK_SUBNET = 311,
    TOK_SWITCH = 312,
    TOK_TABLE = 313,
    TOK_TIME = 314,
    TOK_TIMEOUT = 315,
    TOK_TIMER = 316,
    TOK_TYPE = 317,
    TOK_UNION = 318,
    TOK_VECTOR = 319,
    TOK_WHEN = 320,
    TOK_WHILE = 321,
    TOK_AS = 322,
    TOK_IS = 323,
    TOK_ATTR_ADD_FUNC = 324,
    TOK_ATTR_ENCRYPT = 325,
    TOK_ATTR_DEFAULT = 326,
    TOK_ATTR_OPTIONAL = 327,
    TOK_ATTR_REDEF = 328,
    TOK_ATTR_ROTATE_INTERVAL = 329,
    TOK_ATTR_ROTATE_SIZE = 330,
    TOK_ATTR_DEL_FUNC = 331,
    TOK_ATTR_EXPIRE_FUNC = 332,
    TOK_ATTR_EXPIRE_CREATE = 333,
    TOK_ATTR_EXPIRE_READ = 334,
    TOK_ATTR_EXPIRE_WRITE = 335,
    TOK_ATTR_PERSISTENT = 336,
    TOK_ATTR_SYNCHRONIZED = 337,
    TOK_ATTR_RAW_OUTPUT = 338,
    TOK_ATTR_MERGEABLE = 339,
    TOK_ATTR_PRIORITY = 340,
    TOK_ATTR_LOG = 341,
    TOK_ATTR_ERROR_HANDLER = 342,
    TOK_ATTR_TYPE_COLUMN = 343,
    TOK_ATTR_DEPRECATED = 344,
    TOK_DEBUG = 345,
    TOK_NO_TEST = 346,
    TOK_OR_OR = 347,
    TOK_AND_AND = 348,
    TOK_LE = 349,
    TOK_GE = 350,
    TOK_EQ = 351,
    TOK_NE = 352,
    TOK_IN = 353,
    TOK_NOT_IN = 354,
    TOK_INCR = 355,
    TOK_DECR = 356,
    TOK_HAS_FIELD = 357,
    TOK_HAS_ATTR = 358
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 239 "parse.y" /* yacc.c:355  */

	bool b;
	char* str;
	ID* id;
	id_list* id_l;
	init_class ic;
	Val* val;
	RE_Matcher* re;
	Expr* expr;
	EventExpr* event_expr;
	Stmt* stmt;
	ListExpr* list;
	BroType* type;
	RecordType* record;
	FuncType* func_type;
	TypeList* type_l;
	TypeDecl* type_decl;
	type_decl_list* type_decl_l;
	Case* c_case;
	case_list* case_l;
	Attr* attr;
	attr_list* attr_l;
	attr_tag attrtag;

#line 400 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE yylval;
extern YYLTYPE yylloc;
int yyparse (void);

#endif /* !YY_YY_USR_SRC_RPM_BUILD_BRO_2_6_BUILD_SRC_BROPARSE_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 431 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3099

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  128
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  75
/* YYNRULES -- Number of rules.  */
#define YYNRULES  254
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  706

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   358

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   116,     2,     2,   118,   113,   108,     2,
     121,   122,   111,   109,    92,   110,     2,   112,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    95,   127,
      98,    93,    99,    94,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   119,     2,   120,   107,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   125,   106,   126,   117,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    96,    97,   100,
     101,   102,   103,   104,   105,   114,   115,   123,   124
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   267,   267,   282,   282,   289,   290,   294,   297,   301,
     307,   313,   319,   325,   331,   337,   343,   349,   355,   361,
     367,   373,   379,   385,   391,   397,   403,   409,   415,   421,
     427,   433,   439,   445,   451,   457,   463,   469,   475,   481,
     491,   497,   504,   503,   518,   524,   530,   555,   562,   568,
     568,   568,   575,   581,   588,   594,   587,   636,   636,   645,
     651,   653,   659,   708,   714,   714,   728,   734,   740,   748,
     754,   762,   764,   768,   774,   782,   784,   793,   805,   814,
     823,   828,   833,   838,   843,   848,   853,   858,   863,   868,
     873,   878,   883,   888,   893,   899,   906,   908,   905,   915,
     922,   922,   929,   937,   945,   951,   957,   963,   969,   975,
     981,   987,  1007,  1009,  1017,  1022,  1028,  1039,  1041,  1044,
    1048,  1050,  1052,  1057,  1065,  1071,  1071,  1074,  1080,  1086,
    1092,  1099,  1098,  1106,  1108,  1110,  1105,  1122,  1121,  1130,
    1133,  1136,  1140,  1141,  1144,  1146,  1148,  1150,  1152,  1157,
    1164,  1170,  1178,  1188,  1194,  1187,  1206,  1211,  1220,  1222,
    1227,  1230,  1234,  1235,  1236,  1237,  1241,  1241,  1241,  1244,
    1248,  1250,  1252,  1256,  1258,  1262,  1264,  1272,  1274,  1276,
    1278,  1280,  1282,  1284,  1286,  1288,  1290,  1292,  1294,  1296,
    1298,  1300,  1302,  1304,  1306,  1308,  1310,  1312,  1314,  1319,
    1327,  1335,  1343,  1349,  1355,  1361,  1366,  1371,  1379,  1387,
    1395,  1403,  1411,  1419,  1427,  1435,  1443,  1449,  1458,  1464,
    1472,  1480,  1486,  1491,  1498,  1502,  1523,  1526,  1530,  1533,
    1536,  1541,  1544,  1552,  1558,  1574,  1600,  1605,  1607,  1615,
    1636,  1636,  1641,  1641,  1641,  1646,  1646,  1651,  1687,  1700,
    1703,  1706,  1709,  1712,  1715
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_ADD", "TOK_ADD_TO", "TOK_ADDR",
  "TOK_ANY", "TOK_ATENDIF", "TOK_ATELSE", "TOK_ATIF", "TOK_ATIFDEF",
  "TOK_ATIFNDEF", "TOK_BOOL", "TOK_BREAK", "TOK_CASE", "TOK_OPTION",
  "TOK_CONST", "TOK_CONSTANT", "TOK_COPY", "TOK_COUNT", "TOK_COUNTER",
  "TOK_DEFAULT", "TOK_DELETE", "TOK_DOUBLE", "TOK_ELSE", "TOK_ENUM",
  "TOK_EVENT", "TOK_EXPORT", "TOK_FALLTHROUGH", "TOK_FILE", "TOK_FOR",
  "TOK_FUNCTION", "TOK_GLOBAL", "TOK_HOOK", "TOK_ID", "TOK_IF", "TOK_INT",
  "TOK_INTERVAL", "TOK_LIST", "TOK_LOCAL", "TOK_MODULE", "TOK_NEXT",
  "TOK_OF", "TOK_OPAQUE", "TOK_PATTERN", "TOK_PATTERN_END",
  "TOK_PATTERN_TEXT", "TOK_PORT", "TOK_PRINT", "TOK_RECORD", "TOK_REDEF",
  "TOK_REMOVE_FROM", "TOK_RETURN", "TOK_SCHEDULE", "TOK_SET", "TOK_STRING",
  "TOK_SUBNET", "TOK_SWITCH", "TOK_TABLE", "TOK_TIME", "TOK_TIMEOUT",
  "TOK_TIMER", "TOK_TYPE", "TOK_UNION", "TOK_VECTOR", "TOK_WHEN",
  "TOK_WHILE", "TOK_AS", "TOK_IS", "TOK_ATTR_ADD_FUNC", "TOK_ATTR_ENCRYPT",
  "TOK_ATTR_DEFAULT", "TOK_ATTR_OPTIONAL", "TOK_ATTR_REDEF",
  "TOK_ATTR_ROTATE_INTERVAL", "TOK_ATTR_ROTATE_SIZE", "TOK_ATTR_DEL_FUNC",
  "TOK_ATTR_EXPIRE_FUNC", "TOK_ATTR_EXPIRE_CREATE", "TOK_ATTR_EXPIRE_READ",
  "TOK_ATTR_EXPIRE_WRITE", "TOK_ATTR_PERSISTENT", "TOK_ATTR_SYNCHRONIZED",
  "TOK_ATTR_RAW_OUTPUT", "TOK_ATTR_MERGEABLE", "TOK_ATTR_PRIORITY",
  "TOK_ATTR_LOG", "TOK_ATTR_ERROR_HANDLER", "TOK_ATTR_TYPE_COLUMN",
  "TOK_ATTR_DEPRECATED", "TOK_DEBUG", "TOK_NO_TEST", "','", "'='", "'?'",
  "':'", "TOK_OR_OR", "TOK_AND_AND", "'<'", "'>'", "TOK_LE", "TOK_GE",
  "TOK_EQ", "TOK_NE", "TOK_IN", "TOK_NOT_IN", "'|'", "'^'", "'&'", "'+'",
  "'-'", "'*'", "'/'", "'%'", "TOK_INCR", "TOK_DECR", "'!'", "'~'", "'$'",
  "'['", "']'", "'('", "')'", "TOK_HAS_FIELD", "TOK_HAS_ATTR", "'{'",
  "'}'", "';'", "$accept", "bro", "$@1", "decl_list", "opt_expr", "expr",
  "$@2", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8", "expr_list",
  "opt_expr_list", "enum_body", "enum_body_list", "enum_body_elem", "type",
  "$@9", "$@10", "$@11", "type_list", "type_decl_list", "type_decl",
  "formal_args", "formal_args_decl_list", "formal_args_decl", "decl",
  "$@12", "$@13", "$@14", "$@15", "$@16", "$@17", "conditional_list",
  "conditional", "func_hdr", "func_body", "$@18", "$@19",
  "anonymous_function", "begin_func", "func_params", "opt_type",
  "init_class", "opt_init", "$@20", "$@21", "init", "opt_attr",
  "attr_list", "attr", "stmt", "stmt_list", "event", "case_list", "case",
  "case_type_list", "case_type", "for_head", "local_id_list", "local_id",
  "global_id", "$@22", "def_global_id", "$@23", "$@24", "event_id", "$@25",
  "global_or_event_id", "resolve_id", "opt_no_test", "opt_no_test_block",
  "opt_deprecated", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    44,    61,    63,    58,   347,   348,    60,    62,
     349,   350,   351,   352,   353,   354,   124,    94,    38,    43,
      45,    42,    47,    37,   355,   356,    33,   126,    36,    91,
      93,    40,    41,   357,   358,   123,   125,    59
};
# endif

#define YYPACT_NINF -638

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-638)))

#define YYTABLE_NINF -170

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-170)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -63,  -638,    87,  2419,  2515,  -638,  -638,  -638,   -15,    17,
      30,  -638,  -638,  -638,    -8,  -638,  -638,  -638,   121,   147,
    -638,  -638,  -638,    74,   969,  -638,    42,    59,  -638,  -638,
     141,    65,  2515,    67,    69,    76,  2515,  2515,  2515,  -638,
    2515,  2515,  2515,  2515,   169,  2384,  2515,  2131,  -638,  2515,
     171,   173,   113,  -638,   113,    59,   183,  -638,    59,   113,
      59,    96,  -638,  -638,  -638,   113,   183,   138,  -638,   109,
     221,  -638,  2515,   110,   141,  2515,   202,   112,   119,   120,
     141,   116,  2515,   428,  2515,   124,   127,   158,  -638,   703,
    -638,  -638,   969,  2515,   216,   109,  -638,  2515,  -638,   159,
    2515,  1091,  2515,  -638,  2515,  2196,    24,    24,   205,    24,
      24,    24,    24,   -27,  -638,  2131,   -18,  1351,  2515,  2515,
    2656,  2656,  2515,  2620,  2515,  2515,  2515,  2515,  2515,  2515,
    2515,  2515,  2515,  2515,  2515,  2515,  2515,  2515,  2515,  2515,
    2515,  2515,   220,  2620,  -638,   222,  1416,   133,   135,  2656,
      16,  -638,    16,  1742,  -638,  -638,  -638,  1742,    16,  1742,
    -638,   254,    59,  -638,    16,  -638,  -638,  -638,  -638,  -638,
     824,   168,   113,   945,   146,   143,   168,   -12,  2515,     2,
     168,   -52,   150,   168,  1025,  1156,  2515,  2515,  -638,  -638,
     168,  -638,  1481,   177,   151,   -41,  -638,  -638,  2877,  2515,
     -45,   202,   182,   153,  2515,   154,   394,   232,  2515,   185,
    2515,  -638,  -638,  2131,  2131,  -638,  -638,  -638,  -638,  -638,
    -638,   156,   161,   241,    59,   166,  -638,  -638,  -638,   246,
     247,  -638,  -638,   165,   175,  -638,  -638,   176,  -638,  -638,
     167,   255,  -638,  -638,  -638,  2131,  1546,  2803,  2877,  2903,
    2903,  2903,  2903,  2903,  2903,   103,   103,  1368,  1239,  1498,
     445,   445,    24,    24,    24,  -638,   201,  1611,    20,  2515,
    -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,   267,  -638,
     267,   206,   207,   209,  -638,  -638,   212,   213,   214,   217,
     218,   219,   224,  -638,  -638,  -638,  -638,   225,  -638,  -638,
     228,  -638,  -638,  1742,  -638,   253,  -638,   267,  -638,   184,
    1742,   294,   267,  2656,   969,   168,  -638,  -638,    16,   168,
    2515,   168,  -638,   210,   141,  1676,    16,  -638,   168,  2515,
    -638,   168,  -638,  1741,  1806,   606,  -638,  -638,  2656,   227,
     216,   216,  2131,  -638,   197,  1742,   208,  -638,  -638,  2131,
    -638,  2131,  -638,   216,  2656,  -638,   216,  2656,   290,  -638,
    2656,  2656,  2656,  2656,  2515,  2515,  -638,  -638,  1742,  2358,
    1742,  2515,  2515,  2515,  2515,  2515,  2515,  2515,  2515,  2515,
    2515,  2515,  2515,  -638,  -638,  1742,  -638,  -638,   203,  1742,
    1742,   231,  -638,   267,  -638,   211,  -638,  2515,    21,  -638,
     969,   267,  -638,  1871,  -638,    34,   969,   969,  -638,  1742,
    2656,  -638,  -638,  -638,  -638,  -638,   109,   297,   236,  -638,
     237,  -638,  -638,  -638,  -638,    56,    58,   -23,  -638,  2709,
     215,  2131,   242,   239,  2515,  2131,  -638,   259,  2131,  2131,
    2131,  2131,  2131,  2131,  2131,  2131,  2131,  2131,  2131,  2131,
     260,   297,  -638,   262,   263,  -638,  1742,  -638,  1936,   141,
     277,   308,  1742,   969,  2489,   268,  -638,  -638,   331,  -638,
    -638,  -638,  1742,  -638,   -17,   266,   305,  -638,  -638,  -638,
     365,  2656,  -638,   358,  -638,  -638,  -638,  -638,   310,   278,
    -638,  -638,  -638,   279,  -638,  -638,  -638,   276,  -638,  -638,
    2515,   969,   281,   346,  2737,    54,    73,  -638,  -638,  2515,
    -638,  -638,    -2,  -638,  -638,   297,   315,   289,  -638,  -638,
    2656,  1122,  -638,   291,   365,   168,  2001,  -638,   168,  2515,
     349,  -638,   355,  -638,   969,  1221,   330,   405,  -638,  2656,
    -638,  -638,  -638,  -638,   298,  -638,  -638,  -638,  1286,   389,
     969,  -638,   969,   158,  -638,  -638,  1742,  1742,   158,  -638,
    -638,   302,   304,  -638,   727,  -638,  -638,   848,  -638,  -638,
    -638,   141,   311,   313,  2620,  2620,  2620,  2620,  2620,  2620,
     401,  2620,  2620,  2737,  2737,  2620,  2620,  2620,  2620,  2620,
    2620,  2620,  2620,  2620,  2620,  2620,  2620,  2620,  2620,  2620,
    2620,  2620,  2620,  2620,  2620,  2261,   395,   317,   398,   322,
     400,  2620,  2620,   351,  2515,  -638,    43,    43,    43,    43,
      43,    43,    -5,  2261,  2261,  2261,  2066,  2830,  2950,  2976,
    2976,  2976,  2976,  2976,  2976,   992,   992,  1433,  1304,  1563,
    1628,  1628,    43,    43,    43,  2737,   216,  2737,  2656,  2737,
    2261,  2950,  2620,   327,  2515,  2620,  2620,   328,    61,  2261,
    1807,   329,  2261,  2756,  -638,   411,   361,   362,   363,   364,
     370,   373,   375,   376,   377,   378,   379,   380,  1807,  -638,
    2737,  2620,  2620,  2620,  2620,  2620,  2620,  2620,  2620,  2620,
    2620,  2620,  2620,  1807,  2261,  2261,  2261,  2261,  2261,  2261,
    2261,  2261,  2261,  2261,  2261,  2261
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       6,     3,     0,   224,     0,     1,   147,   148,     0,     0,
       0,   242,   242,   245,     0,   242,   242,   242,     0,   240,
     240,     5,   141,     0,     2,    63,     0,     0,    57,    62,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    64,
       0,     0,     0,     0,     0,     0,     0,     4,    60,     0,
       0,     0,   161,   240,   161,     0,     0,   125,     0,   161,
       0,     0,   240,   245,   240,   161,     0,     0,   153,     0,
     142,   139,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   252,   221,     0,
     222,   223,     0,     0,   119,     0,   157,     0,   239,     0,
       0,     0,    72,    49,    72,     0,    16,    15,     0,    11,
      12,    13,    14,     0,    47,    70,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     8,    54,     0,     0,     0,     0,     0,
     162,   243,   162,   174,   247,   246,     6,   174,   162,   174,
     124,     0,     0,   133,   162,   241,   137,   224,   140,   143,
       0,   250,   161,     0,     0,     0,   250,     0,     0,   161,
     250,     0,     0,   250,     0,     0,     0,     0,   251,   224,
     250,   205,     0,     0,     0,   117,   122,   156,    58,     0,
       0,     0,    71,     0,    72,     0,    66,     0,     0,     0,
       0,    46,     9,    18,    20,    91,    93,    80,    82,    83,
      84,     0,     0,   109,     0,     0,   248,    81,    86,   102,
       0,    88,    90,     0,     0,    87,    92,     0,    85,    89,
       0,     0,    67,   111,    68,    36,     0,    28,    27,    31,
      33,    32,    34,    29,    30,    44,    45,    25,    26,    24,
      17,    19,    21,    22,    23,    40,     0,    70,     0,    72,
      59,   144,   145,   146,   160,   164,   165,   163,   166,   244,
     166,     0,   190,     0,   178,   179,     0,     0,     0,     0,
       0,     0,     0,   188,   189,   192,   193,     0,   196,   197,
       0,   198,   150,   173,   176,     0,   149,   166,   151,     0,
     174,     0,   166,     0,   154,   250,   249,   208,   162,   250,
      72,   250,   209,     0,     0,     0,   162,   207,   250,     0,
     210,   250,   227,     0,     0,     0,   220,    10,     0,   159,
       0,   118,    37,    48,     0,   174,     0,    53,    65,    41,
      42,    69,   100,   119,     0,   105,   119,     0,     0,    96,
       0,     0,     0,     0,     0,     8,    38,    55,   174,     0,
     174,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   175,   126,   174,   131,   152,     0,   174,
     174,     0,   212,   166,   213,     0,   201,     0,     0,   238,
       0,   166,   200,     0,   211,     0,     0,     0,   199,   174,
       0,   121,   120,    61,    52,    50,     0,     0,     0,   108,
       0,   103,   110,   115,   113,     0,     0,     0,   104,    35,
       0,     7,     0,     0,    72,   172,   167,     0,   182,   191,
     177,   180,   181,   183,   184,   185,   186,   187,   194,   195,
       0,     0,   134,     0,     0,   155,   174,   225,     0,     0,
       0,   202,   174,     0,     0,     0,   204,   226,   216,   206,
     123,   158,   174,    43,   254,     0,    73,    75,   106,   107,
      97,     0,    95,     0,    99,    39,    56,   128,    71,     0,
     168,   129,   127,     0,   115,   130,   138,     0,   235,   237,
       0,     0,     0,   218,     0,     0,     0,   232,   224,     0,
      51,   253,     0,    79,   101,    74,     0,     0,   114,   112,
       0,     0,   170,     0,   135,   250,     0,   203,   250,     0,
     233,   224,     0,   224,   230,     0,   254,     0,    76,     0,
      98,    94,   171,   132,     0,   215,   236,   214,     0,     0,
     228,   231,   229,   252,    77,    78,   174,   174,   252,   234,
     224,     0,     0,   224,     0,   116,   136,     0,   217,   219,
      57,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    70,   109,     0,   102,     0,
       0,     0,     0,     0,    72,    49,    16,    15,    11,    12,
      13,    14,     0,    18,    20,    36,     0,    28,    27,    31,
      33,    32,    34,    29,    30,    44,    45,    25,    26,    24,
      17,    19,    21,    22,    23,     0,   119,     0,     0,     0,
      69,    58,     0,     0,    72,     0,     0,     0,     0,    37,
     174,     0,    41,    35,   159,     0,     0,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   173,    50,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   182,   191,   177,   180,   181,   183,
     184,   185,   186,   187,   194,   195
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -638,  -638,  -638,   318,   111,    -4,  -638,  -140,  -201,  -638,
    -638,   -91,  -638,   -38,  -100,    29,  -638,   -32,  -119,  -638,
    -638,  -638,  -344,   -10,  -638,  -345,  -638,  -148,  -638,  -638,
    -638,  -638,  -638,  -638,  -638,   415,     3,  -638,   -34,  -638,
    -638,  -638,  -638,    -6,     5,  -139,  -249,  -638,  -638,  -638,
    -143,  -637,  -298,   -80,  -124,   286,  -638,  -638,  -638,   -44,
    -638,  -638,   -71,    37,  -638,   142,  -638,  -638,   426,  -638,
     424,  -638,  -130,  -529,   -42
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     4,     3,   266,    89,   416,   204,   472,   269,
     432,    97,   108,   202,   203,   475,   476,   477,   424,   423,
     517,   417,   425,   480,   518,   194,   195,   196,    21,   156,
     451,   311,   494,   544,   313,    69,    90,    23,    71,   167,
     391,    48,    95,   209,   150,   278,   368,   369,   490,   436,
     414,   303,   304,    91,    24,   175,   405,   467,   506,   507,
      92,   398,    99,    65,    66,    52,    53,   279,    55,    56,
     155,   243,   317,   189,   513
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      47,   242,   244,   172,   205,   383,    22,   116,   418,   179,
     302,   420,   191,   280,   306,   536,   308,   426,   427,   307,
     275,    96,   323,   678,   560,   312,    70,     1,   101,   563,
     274,   370,   105,   106,   107,   168,   109,   110,   111,   112,
     210,   115,   117,   314,   181,   146,   322,   210,   464,   153,
     327,   340,   157,   330,   159,   465,   678,    67,   385,   152,
     336,   197,   200,   389,   158,   335,   208,   276,   170,   481,
     164,   173,   511,    70,   210,   328,   512,   343,   115,   184,
     185,     6,     7,     8,     9,    10,   341,     5,   655,   192,
     151,   120,   121,   198,    94,   199,   115,   149,   115,   161,
     115,   163,   211,   484,   346,   268,    49,   324,   537,   277,
     583,   584,   210,   459,   213,   214,    94,    57,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    50,   267,
     366,   460,   142,   143,   456,   144,   611,   145,   481,   531,
     481,    51,   462,   481,    54,    61,   310,    58,    59,    60,
     466,   142,   143,    93,   144,   532,   145,   387,   533,   367,
     120,   121,    62,    63,   325,    98,   482,   318,   483,   393,
      94,   665,   333,   334,   326,   392,   100,   401,   102,   394,
     103,   396,   411,   412,   390,   342,    64,   104,   402,    68,
     115,   404,   257,   113,   349,   147,   351,   148,   149,   134,
     135,   136,   137,   138,   139,   140,   141,   154,   355,   409,
     395,   142,   143,   160,   144,   433,   145,   437,     6,     7,
       8,     9,    10,   166,    68,   419,   174,   171,   421,   176,
     177,   178,   450,   180,   428,   186,   453,   454,   187,   188,
     193,   207,   199,   399,   265,   272,   270,   273,   309,   316,
       6,     7,     8,     9,    10,   115,   470,   320,    11,    12,
     321,   329,   338,   339,   210,   345,   347,   348,   350,    13,
      14,   352,   353,   354,    15,    16,    17,   356,   357,   358,
     359,   471,   362,    18,   360,   361,   365,   363,   388,   371,
     372,   657,   373,    19,   658,   374,   375,   376,    22,   386,
     377,   378,   379,   497,   397,    20,   115,   380,   381,   502,
     461,   382,   410,   413,   422,   403,   468,   469,   452,   510,
     415,   474,   501,   457,   489,   485,  -169,  -169,  -169,  -169,
    -169,  -169,  -169,  -169,  -169,  -169,  -169,  -169,  -169,  -169,
    -169,  -169,  -169,  -169,  -169,  -169,  -169,   455,   478,   479,
     429,   431,   519,   508,   486,   435,   487,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   384,
     383,   500,   473,   503,   534,   530,   491,   492,   499,   495,
     496,   509,   514,   458,  -169,   545,   488,   515,   547,   516,
     520,   541,   521,   525,   522,   523,   529,   550,   528,   552,
     539,    25,    26,   561,   562,   540,   549,   504,   543,   511,
     556,   527,   555,   559,   557,    27,   505,    28,    29,   565,
     115,   566,   614,    30,   615,   622,   564,   645,   646,   567,
     647,   648,   649,    31,   652,    25,    26,    32,    33,   660,
     664,   679,    34,   680,   681,   682,   683,   684,    35,    27,
     605,    28,    29,   685,   242,   244,   686,    30,   687,   688,
     689,   690,   691,   692,   305,   654,   430,    31,   693,   612,
     493,    32,    33,   538,   524,   169,    34,   344,   551,   162,
     165,     0,    35,   182,   554,     0,   526,     0,     0,     0,
     613,     0,     0,     0,     0,   535,     0,     0,    40,    41,
      42,    43,   120,   121,   653,     0,     0,   351,     0,     0,
       0,     0,     0,     0,     0,   548,   419,     0,   421,     0,
     428,     0,     0,     0,    36,     0,     0,    37,    38,     0,
      39,     0,    40,    41,    42,    43,    44,    45,     0,    46,
     510,     0,     0,     0,   661,   183,   139,   140,   141,     0,
       0,   541,     0,   142,   143,     0,   144,     0,   145,     0,
     616,   617,   618,   619,   620,   621,     0,   623,   624,     0,
       0,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   355,     0,     0,     0,     0,     0,   650,   651,    72,
     115,     0,     0,     6,     7,     8,     9,    10,     0,    73,
       0,     0,    74,    25,    26,     0,     0,     0,    75,     0,
       0,     0,    76,     0,    77,     0,    78,    27,     0,    28,
      29,    79,     0,     0,     0,    80,     0,    81,   659,     0,
     115,   662,   663,     0,    82,    31,     0,     0,    83,    32,
      33,     0,     0,    84,    34,     0,     0,     0,     0,     0,
      35,    85,    86,     0,     0,     0,     0,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   118,     0,     0,
       0,     0,    36,     0,     0,    37,    38,     0,    39,     0,
      40,    41,    42,    43,    44,    45,     0,    46,     0,     0,
      72,    87,   408,    88,     6,     7,     8,     9,    10,     0,
      73,     0,     0,    74,    25,    26,     0,     0,     0,    75,
       0,     0,     0,    76,   119,    77,     0,    78,    27,     0,
      28,    29,    79,     0,     0,     0,    80,     0,    81,     0,
     120,   121,     0,     0,     0,    82,    31,     0,     0,    83,
      32,    33,     0,     0,    84,    34,     0,     0,     0,     0,
       0,    35,    85,    86,     0,     0,   122,   123,     0,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,     0,     0,     0,
       0,   142,   143,     0,   144,     0,   145,     0,   118,     0,
     190,     0,     0,    36,     0,     0,    37,    38,     0,    39,
       0,    40,    41,    42,    43,    44,    45,     0,    46,     0,
       0,    72,    87,   568,    88,     6,     7,     8,     9,    10,
       0,    73,     0,     0,    74,    25,    26,     0,     0,     0,
      75,     0,     0,     0,    76,   119,    77,     0,    78,    27,
       0,    28,    29,    79,     0,     0,     0,    80,     0,    81,
       0,   120,   121,     0,     0,     0,    82,    31,     0,     0,
      83,    32,    33,     0,     0,    84,    34,     0,     0,     0,
       0,     0,    35,    85,    86,     0,     0,   122,   123,     0,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,     0,     0,
       0,     0,   142,   143,     0,   144,     0,   145,     0,   118,
       0,   315,     0,     0,    36,     0,     0,    37,    38,     0,
      39,     0,    40,    41,    42,    43,    44,    45,     0,    46,
       0,     0,    72,    87,   569,    88,     6,     7,     8,     9,
      10,     0,    73,     0,     0,    74,    25,    26,     0,     0,
       0,    75,     0,     0,     0,    76,   119,    77,     0,    78,
      27,     0,    28,    29,    79,     0,     0,     0,    80,     0,
      81,     0,   120,   121,     0,     0,     0,    82,    31,     0,
       0,    83,    32,    33,     0,     0,    84,    34,     0,   118,
       0,     0,     0,    35,    85,    86,     0,     0,   122,   123,
       0,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   583,
     584,     0,     0,   142,   143,     0,   144,     0,   145,     0,
       0,     0,   319,     0,     0,    36,   119,     0,    37,    38,
       0,    39,     0,    40,    41,    42,    43,    44,    45,     0,
      46,     0,   120,   121,    87,   118,    88,     0,   597,   598,
     599,   600,   601,   602,   603,   604,     0,     0,     0,     0,
     142,   143,     0,   144,     0,   145,     0,     0,   122,   123,
       0,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    25,
      26,     0,   119,   142,   143,     0,   144,     0,   145,     0,
       0,     0,   331,    27,     0,    28,    29,     0,   120,   121,
     118,    30,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    31,     0,     0,     0,    32,    33,     0,     0,     0,
      34,     0,     0,     0,   122,   123,    35,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,     0,     0,   119,     0,   142,
     143,     0,   144,     0,   145,     0,   201,     0,     0,     0,
       0,     0,     0,   120,   121,   118,     0,     0,    36,     0,
       0,    37,    38,     0,    39,     0,    40,    41,    42,    43,
      44,    45,     0,    46,     0,     0,     0,     0,   542,   122,
     123,     0,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
       0,     0,   119,     0,   142,   143,     0,   144,     0,   145,
       0,   332,     0,     0,     0,     0,     0,     0,   120,   121,
     118,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   120,   121,     0,     0,
       0,     0,     0,     0,   122,   123,     0,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,     0,     0,   119,     0,   142,
     143,     0,   144,     0,   145,     0,   553,   136,   137,   138,
     139,   140,   141,   120,   121,   118,     0,   142,   143,     0,
     144,     0,   145,     0,     0,     0,     0,     0,     0,     0,
       0,   583,   584,     0,     0,     0,     0,     0,     0,   122,
     123,     0,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
       0,     0,   119,     0,   142,   143,     0,   144,     0,   145,
       0,   558,   599,   600,   601,   602,   603,   604,   120,   121,
     118,     0,   142,   143,     0,   144,     0,   145,     0,     0,
       0,     0,     0,     0,     0,   120,   121,     0,     0,     0,
       0,     0,     0,     0,   122,   123,     0,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,     0,     0,   119,     0,   142,
     143,     0,   144,   212,   145,   135,   136,   137,   138,   139,
     140,   141,     0,   120,   121,   118,   142,   143,     0,   144,
       0,   145,     0,     0,     0,     0,     0,     0,     0,     0,
     583,   584,     0,     0,     0,     0,     0,     0,     0,   122,
     123,     0,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
       0,     0,   119,     0,   142,   143,     0,   144,   271,   145,
     598,   599,   600,   601,   602,   603,   604,     0,   120,   121,
     581,   142,   143,     0,   144,     0,   145,     0,     0,     0,
       0,     0,     0,     0,     0,   120,   121,     0,     0,     0,
       0,     0,     0,     0,   122,   123,     0,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,     0,     0,   582,     0,   142,
     143,     0,   144,   337,   145,     0,     0,   137,   138,   139,
     140,   141,     0,   583,   584,   581,   142,   143,     0,   144,
       0,   145,     0,     0,     0,     0,     0,     0,     0,     0,
     583,   584,     0,     0,     0,     0,     0,     0,     0,   585,
     586,   364,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,   582,     0,   142,   143,     0,   144,     0,   145,
       0,     0,   600,   601,   602,   603,   604,     0,   583,   584,
     118,   142,   143,     0,   144,     0,   145,     0,     0,     0,
       0,     0,     0,     0,     0,   583,   584,     0,     0,     0,
       0,     0,     0,     0,   585,   586,    -7,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,     0,     0,   119,     0,   142,
     143,     0,   144,     0,   145,     0,     0,     0,     0,   602,
     603,   604,     0,   120,   121,   118,   142,   143,     0,   144,
       0,   145,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   122,
     123,     0,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
       0,     0,   119,     0,   142,   143,     0,   144,   400,   145,
       0,     0,     0,     0,     0,     0,     0,     0,   120,   121,
     118,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,     0,   122,   123,     0,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,     0,     0,   119,     0,   142,
     143,     0,   144,   406,   145,     0,     0,     0,     0,     0,
       0,     0,     0,   120,   121,   118,   666,   667,   668,   284,
     285,   669,   670,   671,   672,   673,   674,   675,   293,   294,
     295,   296,   676,   298,   299,   677,   301,     0,     0,   122,
     123,     0,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
       0,     0,   119,     0,   142,   143,     0,   144,   407,   145,
       0,     0,     0,     0,     0,     0,     0,     0,   120,   121,
     118,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   122,   123,     0,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,     0,     0,   119,     0,   142,
     143,     0,   144,   463,   145,     0,     0,     0,     0,     0,
       0,     0,     0,   120,   121,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   122,
     123,     0,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
       0,     0,   119,     0,   142,   143,     0,   144,   498,   145,
       0,     0,     0,     0,     0,     0,     0,     0,   120,   121,
     581,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   122,   123,     0,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,     0,     0,   582,     0,   142,
     143,     0,   144,   546,   145,     0,     0,     0,     0,     0,
       0,     0,     0,   583,   584,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   585,
     586,   656,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,   119,     0,   142,   143,     0,   144,     0,   145,
       0,     0,     0,     0,     0,     0,     0,     0,   120,   121,
     118,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   122,   123,     0,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,     0,     0,   119,     0,   142,
     143,     0,   144,     0,   145,     0,     0,     0,     0,     0,
       0,     0,     0,   120,   121,   581,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   122,
     123,     0,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   206,   135,   136,   137,   138,   139,   140,   141,
       0,     0,   582,     0,   142,   143,     0,   144,     0,   145,
       0,     0,     0,     0,     0,     0,     0,     0,   583,   584,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   585,   586,     0,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,    25,    26,     0,     0,   142,
     143,     0,   144,     0,   145,     0,     0,     0,     0,    27,
       0,    28,    29,     0,     0,     0,     0,    30,     0,     0,
       0,    25,    26,     0,     0,     0,     0,    31,     0,     0,
       0,    32,    33,     0,     0,    27,    34,    28,    29,     0,
       0,     0,    35,    30,     0,     0,     6,     7,     8,     9,
      10,     0,     0,    31,    11,    12,     0,    32,    33,     0,
       0,     0,    34,     0,     0,    13,    14,     0,    35,     0,
      15,    16,    17,     0,     0,     0,     0,     0,     0,    18,
       0,     0,     0,     0,    36,     0,     0,    37,    38,    19,
      39,     0,    40,    41,    42,    43,    44,    45,     0,    46,
       0,    20,     0,   434,     0,     0,     0,     0,     0,     0,
      36,     0,     0,    37,    38,     0,    39,     0,    40,    41,
      42,    43,    44,    45,   114,    46,    25,    26,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      27,     0,   570,    29,     0,     0,     0,     0,   571,     0,
       0,     0,    25,    26,     0,     0,     0,     0,    31,     0,
       0,     0,    32,   572,     0,     0,    27,   573,    28,    29,
       0,   504,     0,    35,    30,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    31,     0,     0,     0,    32,    33,
       0,     0,     0,    34,     0,     0,     0,     0,     0,    35,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    36,     0,     0,   574,   575,
       0,    39,     0,   576,   577,   578,   579,   580,    45,     0,
      46,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    36,     0,     0,    37,    38,     0,    39,     0,    40,
      41,    42,    43,    44,    45,     0,    46,    25,    26,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    27,     0,   570,    29,     0,     0,     0,     0,   571,
       0,   215,   216,     0,     0,     0,     0,     0,   217,    31,
       0,     0,     0,    32,   572,   218,   219,     0,   573,   220,
       0,   221,   222,     0,    35,   223,     0,   224,     0,   225,
     226,     0,   227,   228,   229,     0,     0,     0,     0,   230,
     231,     0,     0,   232,     0,   233,     0,     0,     0,     0,
     234,   235,   236,     0,   237,   238,     0,   239,     0,   240,
     241,     0,     0,     0,     0,     0,    36,     0,     0,   574,
     575,     0,    39,     0,   576,   577,   578,   579,   580,    45,
       0,    46,   215,   216,     0,     0,     0,     0,     0,   217,
       0,     0,     0,     0,     0,     0,   218,   219,     0,     0,
     220,     0,   221,   222,     0,     0,   606,     0,   607,     0,
     225,   226,     0,   227,   228,   608,   120,   121,     0,     0,
     230,   231,     0,     0,   232,     0,   233,     0,     0,     0,
       0,   234,   235,   236,     0,   609,   238,     0,   239,     0,
     240,   610,     0,   123,     0,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   583,   584,     0,     0,   142,   143,     0,
     144,     0,   145,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     586,     0,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     120,   121,     0,     0,   142,   143,     0,   144,     0,   145,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   583,   584,     0,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,     0,     0,     0,
       0,   142,   143,     0,   144,     0,   145,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   120,   121,     0,     0,   142,   143,
       0,   144,     0,   145,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     120,   121,     0,     0,     0,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,     0,     0,     0,     0,   142,   143,     0,   144,     0,
     145,  -170,  -170,  -170,  -170,  -170,  -170,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   583,   584,     0,
       0,   142,   143,     0,   144,     0,   145,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   583,   584,     0,     0,     0,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,     0,     0,     0,     0,   142,   143,
       0,   144,     0,   145,  -170,  -170,  -170,  -170,  -170,  -170,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
       0,     0,     0,     0,   142,   143,     0,   144,     0,   145
};

static const yytype_int16 yycheck[] =
{
       4,   120,   121,    74,   104,   303,     3,    45,   353,    80,
     153,   356,    92,   152,   157,    17,   159,   361,   362,   158,
       4,    27,    34,   660,   553,   164,    23,    90,    32,   558,
     149,   280,    36,    37,    38,    69,    40,    41,    42,    43,
      92,    45,    46,   167,    82,    49,   176,    92,    14,    55,
     180,    92,    58,   183,    60,    21,   693,    20,   307,    54,
     190,    95,   100,   312,    59,   189,    93,    51,    72,    92,
      65,    75,    89,    70,    92,   127,    93,   122,    82,    83,
      84,     7,     8,     9,    10,    11,   127,     0,    93,    93,
      53,    67,    68,    97,   121,    93,   100,    95,   102,    62,
     104,    64,   120,   126,   204,   143,   121,   119,   110,    93,
      67,    68,    92,    92,   118,   119,   121,   125,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   121,   143,
     120,   120,   118,   119,   393,   121,    92,   123,    92,    95,
      92,   121,   401,    92,    12,    34,   162,    15,    16,    17,
     126,   118,   119,   121,   121,    92,   123,   310,    95,   269,
      67,    68,    25,    26,   178,    34,   120,   172,   120,   318,
     121,   120,   186,   187,   179,   315,   121,   326,   121,   319,
     121,   321,   340,   341,   313,   199,    49,   121,   328,   125,
     204,   331,   206,    34,   208,    34,   210,    34,    95,   106,
     107,   108,   109,   110,   111,   112,   113,    34,   224,   338,
     320,   118,   119,   127,   121,   368,   123,   370,     7,     8,
       9,    10,    11,    95,   125,   354,    34,   127,   357,   127,
     121,   121,   385,   127,   363,   121,   389,   390,   121,    91,
      34,    46,    93,   324,    34,   122,    34,   122,     4,    91,
       7,     8,     9,    10,    11,   269,   409,   121,    15,    16,
     127,   121,    95,   122,    92,   122,   122,    45,    93,    26,
      27,   125,   121,    42,    31,    32,    33,   121,    42,    42,
     125,   410,   125,    40,   119,   119,    95,    42,     4,    93,
      93,   646,    93,    50,   648,    93,    93,    93,   305,   125,
      93,    93,    93,   456,   104,    62,   320,    93,    93,   462,
     400,    93,    95,   126,    34,   329,   406,   407,   125,   472,
     122,    34,    24,   122,   434,   120,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,   126,   122,   122,
     364,   365,   481,    95,   122,   369,   127,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   126,
     678,   104,   416,   463,   508,   504,   127,   127,   459,   127,
     127,    60,   126,   397,   127,   525,   434,    92,   528,    34,
      42,   520,    92,   127,   126,   126,    60,   531,   127,   533,
      95,    17,    18,   556,   557,   126,    67,    62,   127,    89,
     539,   501,    17,    34,   126,    31,   464,    33,    34,   127,
     434,   127,   121,    39,   121,    34,   560,    42,   121,   563,
      42,   119,    42,    49,    93,    17,    18,    53,    54,   122,
     122,   122,    58,    42,    93,    93,    93,    93,    64,    31,
     464,    33,    34,    93,   583,   584,    93,    39,    93,    93,
      93,    93,    93,    93,   156,   615,   365,    49,   679,   570,
     451,    53,    54,   515,   494,    70,    58,   201,   532,    63,
      66,    -1,    64,    65,   536,    -1,   500,    -1,    -1,    -1,
     571,    -1,    -1,    -1,    -1,   509,    -1,    -1,   114,   115,
     116,   117,    67,    68,   614,    -1,    -1,   521,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   529,   645,    -1,   647,    -1,
     649,    -1,    -1,    -1,   106,    -1,    -1,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
     693,    -1,    -1,    -1,   654,   127,   111,   112,   113,    -1,
      -1,   680,    -1,   118,   119,    -1,   121,    -1,   123,    -1,
     574,   575,   576,   577,   578,   579,    -1,   581,   582,    -1,
      -1,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   607,    -1,    -1,    -1,    -1,    -1,   611,   612,     3,
     614,    -1,    -1,     7,     8,     9,    10,    11,    -1,    13,
      -1,    -1,    16,    17,    18,    -1,    -1,    -1,    22,    -1,
      -1,    -1,    26,    -1,    28,    -1,    30,    31,    -1,    33,
      34,    35,    -1,    -1,    -1,    39,    -1,    41,   652,    -1,
     654,   655,   656,    -1,    48,    49,    -1,    -1,    52,    53,
      54,    -1,    -1,    57,    58,    -1,    -1,    -1,    -1,    -1,
      64,    65,    66,    -1,    -1,    -1,    -1,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     4,    -1,    -1,
      -1,    -1,   106,    -1,    -1,   109,   110,    -1,   112,    -1,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,    -1,
       3,   125,   126,   127,     7,     8,     9,    10,    11,    -1,
      13,    -1,    -1,    16,    17,    18,    -1,    -1,    -1,    22,
      -1,    -1,    -1,    26,    51,    28,    -1,    30,    31,    -1,
      33,    34,    35,    -1,    -1,    -1,    39,    -1,    41,    -1,
      67,    68,    -1,    -1,    -1,    48,    49,    -1,    -1,    52,
      53,    54,    -1,    -1,    57,    58,    -1,    -1,    -1,    -1,
      -1,    64,    65,    66,    -1,    -1,    93,    94,    -1,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,    -1,    -1,
      -1,   118,   119,    -1,   121,    -1,   123,    -1,     4,    -1,
     127,    -1,    -1,   106,    -1,    -1,   109,   110,    -1,   112,
      -1,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
      -1,     3,   125,   126,   127,     7,     8,     9,    10,    11,
      -1,    13,    -1,    -1,    16,    17,    18,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    26,    51,    28,    -1,    30,    31,
      -1,    33,    34,    35,    -1,    -1,    -1,    39,    -1,    41,
      -1,    67,    68,    -1,    -1,    -1,    48,    49,    -1,    -1,
      52,    53,    54,    -1,    -1,    57,    58,    -1,    -1,    -1,
      -1,    -1,    64,    65,    66,    -1,    -1,    93,    94,    -1,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,    -1,
      -1,    -1,   118,   119,    -1,   121,    -1,   123,    -1,     4,
      -1,   127,    -1,    -1,   106,    -1,    -1,   109,   110,    -1,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,    -1,     3,   125,   126,   127,     7,     8,     9,    10,
      11,    -1,    13,    -1,    -1,    16,    17,    18,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    26,    51,    28,    -1,    30,
      31,    -1,    33,    34,    35,    -1,    -1,    -1,    39,    -1,
      41,    -1,    67,    68,    -1,    -1,    -1,    48,    49,    -1,
      -1,    52,    53,    54,    -1,    -1,    57,    58,    -1,     4,
      -1,    -1,    -1,    64,    65,    66,    -1,    -1,    93,    94,
      -1,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    67,
      68,    -1,    -1,   118,   119,    -1,   121,    -1,   123,    -1,
      -1,    -1,   127,    -1,    -1,   106,    51,    -1,   109,   110,
      -1,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,    67,    68,   125,     4,   127,    -1,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,    -1,    -1,    -1,
     118,   119,    -1,   121,    -1,   123,    -1,    -1,    93,    94,
      -1,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    17,
      18,    -1,    51,   118,   119,    -1,   121,    -1,   123,    -1,
      -1,    -1,   127,    31,    -1,    33,    34,    -1,    67,    68,
       4,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    -1,    -1,    -1,    53,    54,    -1,    -1,    -1,
      58,    -1,    -1,    -1,    93,    94,    64,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,    -1,    51,    -1,   118,
     119,    -1,   121,    -1,   123,    -1,   125,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    68,     4,    -1,    -1,   106,    -1,
      -1,   109,   110,    -1,   112,    -1,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,    -1,    -1,    -1,   126,    93,
      94,    -1,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,    -1,    51,    -1,   118,   119,    -1,   121,    -1,   123,
      -1,   125,    -1,    -1,    -1,    -1,    -1,    -1,    67,    68,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    94,    -1,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,    -1,    51,    -1,   118,
     119,    -1,   121,    -1,   123,    -1,   125,   108,   109,   110,
     111,   112,   113,    67,    68,     4,    -1,   118,   119,    -1,
     121,    -1,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      94,    -1,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,    -1,    51,    -1,   118,   119,    -1,   121,    -1,   123,
      -1,   125,   108,   109,   110,   111,   112,   113,    67,    68,
       4,    -1,   118,   119,    -1,   121,    -1,   123,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    94,    -1,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,    -1,    51,    -1,   118,
     119,    -1,   121,   122,   123,   107,   108,   109,   110,   111,
     112,   113,    -1,    67,    68,     4,   118,   119,    -1,   121,
      -1,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      94,    -1,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,    -1,    51,    -1,   118,   119,    -1,   121,   122,   123,
     107,   108,   109,   110,   111,   112,   113,    -1,    67,    68,
       4,   118,   119,    -1,   121,    -1,   123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    94,    -1,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,    -1,    51,    -1,   118,
     119,    -1,   121,   122,   123,    -1,    -1,   109,   110,   111,
     112,   113,    -1,    67,    68,     4,   118,   119,    -1,   121,
      -1,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,    -1,    51,    -1,   118,   119,    -1,   121,    -1,   123,
      -1,    -1,   109,   110,   111,   112,   113,    -1,    67,    68,
       4,   118,   119,    -1,   121,    -1,   123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,    -1,    51,    -1,   118,
     119,    -1,   121,    -1,   123,    -1,    -1,    -1,    -1,   111,
     112,   113,    -1,    67,    68,     4,   118,   119,    -1,   121,
      -1,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      94,    -1,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,    -1,    51,    -1,   118,   119,    -1,   121,   122,   123,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    68,
       4,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    -1,    93,    94,    -1,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,    -1,    51,    -1,   118,
     119,    -1,   121,   122,   123,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    68,     4,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    -1,    93,
      94,    -1,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,    -1,    51,    -1,   118,   119,    -1,   121,   122,   123,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    68,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    94,    -1,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,    -1,    51,    -1,   118,
     119,    -1,   121,   122,   123,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    68,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      94,    -1,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,    -1,    51,    -1,   118,   119,    -1,   121,   122,   123,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    68,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    94,    -1,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,    -1,    51,    -1,   118,
     119,    -1,   121,   122,   123,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    68,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,    -1,    51,    -1,   118,   119,    -1,   121,    -1,   123,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    68,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    94,    -1,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,    -1,    51,    -1,   118,
     119,    -1,   121,    -1,   123,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    68,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      94,    -1,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,    -1,    51,    -1,   118,   119,    -1,   121,    -1,   123,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    94,    -1,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    17,    18,    -1,    -1,   118,
     119,    -1,   121,    -1,   123,    -1,    -1,    -1,    -1,    31,
      -1,    33,    34,    -1,    -1,    -1,    -1,    39,    -1,    -1,
      -1,    17,    18,    -1,    -1,    -1,    -1,    49,    -1,    -1,
      -1,    53,    54,    -1,    -1,    31,    58,    33,    34,    -1,
      -1,    -1,    64,    39,    -1,    -1,     7,     8,     9,    10,
      11,    -1,    -1,    49,    15,    16,    -1,    53,    54,    -1,
      -1,    -1,    58,    -1,    -1,    26,    27,    -1,    64,    -1,
      31,    32,    33,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    -1,   106,    -1,    -1,   109,   110,    50,
     112,    -1,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,    62,    -1,   125,    -1,    -1,    -1,    -1,    -1,    -1,
     106,    -1,    -1,   109,   110,    -1,   112,    -1,   114,   115,
     116,   117,   118,   119,   120,   121,    17,    18,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      31,    -1,    33,    34,    -1,    -1,    -1,    -1,    39,    -1,
      -1,    -1,    17,    18,    -1,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    53,    54,    -1,    -1,    31,    58,    33,    34,
      -1,    62,    -1,    64,    39,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,    53,    54,
      -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,   109,   110,
      -1,   112,    -1,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   106,    -1,    -1,   109,   110,    -1,   112,    -1,   114,
     115,   116,   117,   118,   119,    -1,   121,    17,    18,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    31,    -1,    33,    34,    -1,    -1,    -1,    -1,    39,
      -1,     5,     6,    -1,    -1,    -1,    -1,    -1,    12,    49,
      -1,    -1,    -1,    53,    54,    19,    20,    -1,    58,    23,
      -1,    25,    26,    -1,    64,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    -1,    -1,    -1,    -1,    43,
      44,    -1,    -1,    47,    -1,    49,    -1,    -1,    -1,    -1,
      54,    55,    56,    -1,    58,    59,    -1,    61,    -1,    63,
      64,    -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,   109,
     110,    -1,   112,    -1,   114,   115,   116,   117,   118,   119,
      -1,   121,     5,     6,    -1,    -1,    -1,    -1,    -1,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    -1,    -1,
      23,    -1,    25,    26,    -1,    -1,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    67,    68,    -1,    -1,
      43,    44,    -1,    -1,    47,    -1,    49,    -1,    -1,    -1,
      -1,    54,    55,    56,    -1,    58,    59,    -1,    61,    -1,
      63,    64,    -1,    94,    -1,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    67,    68,    -1,    -1,   118,   119,    -1,
     121,    -1,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    -1,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      67,    68,    -1,    -1,   118,   119,    -1,   121,    -1,   123,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    68,    -1,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,    -1,    -1,
      -1,   118,   119,    -1,   121,    -1,   123,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    67,    68,    -1,    -1,   118,   119,
      -1,   121,    -1,   123,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      67,    68,    -1,    -1,    -1,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,    -1,    -1,    -1,   118,   119,    -1,   121,    -1,
     123,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    67,    68,    -1,
      -1,   118,   119,    -1,   121,    -1,   123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    68,    -1,    -1,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,    -1,    -1,    -1,   118,   119,
      -1,   121,    -1,   123,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,    -1,    -1,    -1,   118,   119,    -1,   121,    -1,   123
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    90,   129,   131,   130,     0,     7,     8,     9,    10,
      11,    15,    16,    26,    27,    31,    32,    33,    40,    50,
      62,   156,   164,   165,   182,    17,    18,    31,    33,    34,
      39,    49,    53,    54,    58,    64,   106,   109,   110,   112,
     114,   115,   116,   117,   118,   119,   121,   133,   169,   121,
     121,   121,   193,   194,   193,   196,   197,   125,   193,   193,
     193,    34,    25,    26,    49,   191,   192,   191,   125,   163,
     164,   166,     3,    13,    16,    22,    26,    28,    30,    35,
      39,    41,    48,    52,    57,    65,    66,   125,   127,   133,
     164,   181,   188,   121,   121,   170,   171,   139,    34,   190,
     121,   133,   121,   121,   121,   133,   133,   133,   140,   133,
     133,   133,   133,    34,   120,   133,   141,   133,     4,    51,
      67,    68,    93,    94,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   118,   119,   121,   123,   133,    34,    34,    95,
     172,   191,   172,   171,    34,   198,   157,   171,   172,   171,
     127,   191,   196,   191,   172,   198,    95,   167,   166,   163,
     133,   127,   190,   133,    34,   183,   127,   121,   121,   190,
     127,   141,    65,   127,   133,   133,   121,   121,    91,   201,
     127,   181,   133,    34,   153,   154,   155,   166,   133,    93,
     141,   125,   141,   142,   135,   142,   106,    46,    93,   171,
      92,   120,   122,   133,   133,     5,     6,    12,    19,    20,
      23,    25,    26,    29,    31,    33,    34,    36,    37,    38,
      43,    44,    47,    49,    54,    55,    56,    58,    59,    61,
      63,    64,   146,   199,   146,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,    34,   132,   133,   141,   137,
      34,   122,   122,   122,   146,     4,    51,    93,   173,   195,
     173,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,   178,   179,   180,   131,   178,   173,   178,     4,
     171,   159,   173,   162,   182,   127,    91,   200,   172,   127,
     121,   127,   200,    34,   119,   133,   172,   200,   127,   121,
     200,   127,   125,   133,   133,   182,   200,   122,    95,   122,
      92,   127,   133,   122,   183,   122,   142,   122,    45,   133,
      93,   133,   125,   121,    42,   171,   121,    42,    42,   125,
     119,   119,   125,    42,    95,    95,   120,   142,   174,   175,
     174,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,   180,   126,   174,   125,   178,     4,   174,
     146,   168,   200,   173,   200,   142,   200,   104,   189,   190,
     122,   173,   200,   133,   200,   184,   122,   122,   126,   146,
      95,   155,   155,   126,   178,   122,   134,   149,   153,   146,
     153,   146,    34,   147,   146,   150,   150,   150,   146,   133,
     132,   133,   138,   178,   125,   133,   177,   178,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     178,   158,   125,   178,   178,   126,   174,   122,   133,    92,
     120,   181,   174,   122,    14,    21,   126,   185,   181,   181,
     178,   146,   136,   166,    34,   143,   144,   145,   122,   122,
     151,    92,   120,   120,   126,   120,   122,   127,   141,   142,
     176,   127,   127,   143,   160,   127,   127,   178,   122,   190,
     104,    24,   178,   181,    62,   141,   186,   187,    95,    60,
     178,    89,    93,   202,   126,    92,    34,   148,   152,   146,
      42,    92,   126,   126,   151,   127,   133,   181,   127,    60,
     146,    95,    92,    95,   182,   133,    17,   110,   145,    95,
     126,   146,   126,   127,   161,   200,   122,   200,   133,    67,
     182,   187,   182,   125,   202,    17,   146,   126,   125,    34,
     201,   178,   178,   201,   182,   127,   127,   182,   126,   126,
      33,    39,    54,    58,   109,   110,   114,   115,   116,   117,
     118,     4,    51,    67,    68,    93,    94,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   133,    29,    31,    38,    58,
      64,    92,   139,   190,   121,   121,   133,   133,   133,   133,
     133,   133,    34,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,    42,   121,    42,   119,    42,
     133,   133,    93,   142,   135,    93,    95,   153,   150,   133,
     122,   142,   133,   133,   122,   120,    69,    70,    71,    74,
      75,    76,    77,    78,    79,    80,    85,    88,   179,   122,
      42,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,   136,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   128,   129,   130,   129,   131,   131,   132,   132,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   134,   133,   133,   133,   133,   133,   133,   135,
     136,   133,   133,   133,   137,   138,   133,   139,   133,   133,
     133,   133,   133,   133,   140,   133,   133,   133,   133,   141,
     141,   142,   142,   143,   143,   144,   144,   145,   145,   145,
     146,   146,   146,   146,   146,   146,   146,   146,   146,   146,
     146,   146,   146,   146,   146,   146,   147,   148,   146,   146,
     149,   146,   146,   146,   146,   146,   146,   146,   146,   146,
     146,   146,   150,   150,   151,   151,   152,   153,   153,   153,
     154,   154,   154,   155,   156,   157,   156,   156,   156,   156,
     156,   158,   156,   159,   160,   161,   156,   162,   156,   156,
     156,   156,   163,   163,   164,   164,   164,   164,   164,   165,
     165,   165,   165,   167,   168,   166,   169,   170,   171,   171,
     172,   172,   173,   173,   173,   173,   175,   176,   174,   174,
     177,   177,   177,   178,   178,   179,   179,   180,   180,   180,
     180,   180,   180,   180,   180,   180,   180,   180,   180,   180,
     180,   180,   180,   180,   180,   180,   180,   180,   180,   181,
     181,   181,   181,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   182,   182,   183,   184,   184,   185,   185,
     185,   186,   186,   187,   187,   188,   188,   189,   189,   190,
     192,   191,   194,   195,   193,   197,   196,   198,   199,   200,
     200,   201,   201,   202,   202
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     0,     3,     2,     0,     1,     0,     3,
       4,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     5,     3,     4,     4,     6,
       3,     4,     0,     6,     3,     3,     3,     2,     4,     0,
       0,     7,     5,     4,     0,     0,     6,     0,     3,     3,
       1,     5,     1,     1,     0,     4,     3,     3,     3,     3,
       1,     1,     0,     1,     2,     1,     3,     4,     4,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     6,     4,     0,     0,     6,     4,
       0,     5,     1,     3,     3,     2,     4,     4,     3,     1,
       3,     1,     3,     1,     2,     0,     5,     1,     2,     0,
       3,     3,     1,     4,     3,     0,     5,     7,     7,     7,
       7,     0,     9,     0,     0,     0,    12,     0,     7,     2,
       3,     1,     1,     2,     4,     4,     4,     1,     1,     4,
       4,     4,     5,     0,     0,     5,     3,     1,     5,     3,
       2,     0,     0,     1,     1,     1,     0,     0,     3,     0,
       3,     4,     1,     1,     0,     2,     1,     3,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     3,     1,     1,     3,     3,     1,     1,     1,     4,
       4,     4,     5,     7,     5,     2,     5,     3,     3,     3,
       3,     4,     4,     4,     8,     8,     5,    11,     6,    12,
       3,     1,     1,     2,     0,     4,     2,     0,     4,     4,
       3,     3,     1,     2,     4,     6,     8,     3,     1,     1,
       0,     2,     0,     0,     3,     0,     2,     1,     1,     1,
       0,     1,     0,     1,     0
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 268 "parse.y" /* yacc.c:1648  */
    {
			if ( stmts )
				stmts->AsStmtList()->Stmts().append((yyvsp[0].stmt));
			else
				stmts = (yyvsp[0].stmt);

			// Any objects creates from hereon out should not
			// have file positions associated with them.
			set_location(no_location);
			}
#line 2578 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 3:
#line 282 "parse.y" /* yacc.c:1648  */
    { in_debug = true; }
#line 2584 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 4:
#line 283 "parse.y" /* yacc.c:1648  */
    {
			g_curr_debug_expr = (yyvsp[0].expr);
			}
#line 2592 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 7:
#line 295 "parse.y" /* yacc.c:1648  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 2598 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 8:
#line 297 "parse.y" /* yacc.c:1648  */
    { (yyval.expr) = 0; }
#line 2604 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 9:
#line 302 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = (yyvsp[-1].expr); (yyval.expr)->MarkParen();
			}
#line 2613 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 10:
#line 308 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new CloneExpr((yyvsp[-1].expr));
			}
#line 2622 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 11:
#line 314 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_INCR, (yyvsp[0].expr));
			}
#line 2631 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 12:
#line 320 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_DECR, (yyvsp[0].expr));
			}
#line 2640 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 13:
#line 326 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NotExpr((yyvsp[0].expr));
			}
#line 2649 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 14:
#line 332 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new ComplementExpr((yyvsp[0].expr));
			}
#line 2658 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 15:
#line 338 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NegExpr((yyvsp[0].expr));
			}
#line 2667 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 16:
#line 344 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new PosExpr((yyvsp[0].expr));
			}
#line 2676 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 17:
#line 350 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new AddExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2685 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 18:
#line 356 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new AddToExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2694 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 19:
#line 362 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new SubExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2703 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 20:
#line 368 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RemoveFromExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2712 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 21:
#line 374 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new TimesExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2721 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 22:
#line 380 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new DivideExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2730 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 23:
#line 386 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new ModExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2739 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 24:
#line 392 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2748 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 25:
#line 398 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2757 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 26:
#line 404 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_XOR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2766 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 27:
#line 410 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_AND_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2775 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 28:
#line 416 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_OR_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2784 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 29:
#line 422 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_EQ, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2793 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 30:
#line 428 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_NE, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2802 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 31:
#line 434 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2811 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 32:
#line 440 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LE, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2820 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 33:
#line 446 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2829 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 34:
#line 452 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GE, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2838 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 35:
#line 458 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new CondExpr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2847 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 36:
#line 464 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = get_assign_expr((yyvsp[-2].expr), (yyvsp[0].expr), in_init);
			}
#line 2856 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 37:
#line 470 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = add_and_assign_local((yyvsp[-2].id), (yyvsp[0].expr), new Val(1, TYPE_BOOL));
			}
#line 2865 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 38:
#line 476 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new IndexExpr((yyvsp[-3].expr), (yyvsp[-1].list));
			}
#line 2874 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 39:
#line 482 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-5]), (yylsp[0]));
			Expr* low = (yyvsp[-3].expr) ? (yyvsp[-3].expr) : new ConstExpr(new Val(0, TYPE_COUNT));
			Expr* high = (yyvsp[-1].expr) ? (yyvsp[-1].expr) : new SizeExpr((yyvsp[-5].expr));
			ListExpr* le = new ListExpr(low);
			le->Append(high);
			(yyval.expr) = new IndexExpr((yyvsp[-5].expr), le, true);
			}
#line 2887 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 40:
#line 492 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new FieldExpr((yyvsp[-2].expr), (yyvsp[0].str));
			}
#line 2896 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 41:
#line 498 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new FieldAssignExpr((yyvsp[-2].str), (yyvsp[0].expr));
			}
#line 2905 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 42:
#line 504 "parse.y" /* yacc.c:1648  */
    {
			func_id = current_scope()->GenerateTemporary("anonymous-function");
			func_id->SetInferReturnType(true);
			begin_func(func_id,
				   current_module.c_str(),
				   FUNC_FLAVOR_FUNCTION,
				   0,
				   (yyvsp[-1].func_type));
			}
#line 2919 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 43:
#line 514 "parse.y" /* yacc.c:1648  */
    {
			(yyval.expr) = new FieldAssignExpr((yyvsp[-4].str), new ConstExpr(func_id->ID_Val()));
			}
#line 2927 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 44:
#line 519 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new InExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2936 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 45:
#line 525 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new NotExpr(new InExpr((yyvsp[-2].expr), (yyvsp[0].expr)));
			}
#line 2945 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 46:
#line 531 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));

			bool is_record_ctor = true;

			// If every expression in the list is a field assignment,
			// then treat it as a record constructor, else as a list
			// used for an initializer.

			for ( int i = 0; i < (yyvsp[-1].list)->Exprs().length(); ++i )
				{
				if ( (yyvsp[-1].list)->Exprs()[i]->Tag() != EXPR_FIELD_ASSIGN )
					{
					is_record_ctor = false;
					break;
					}
				}

			if ( is_record_ctor )
				(yyval.expr) = new RecordConstructorExpr((yyvsp[-1].list));
			else
				(yyval.expr) = (yyvsp[-1].list);
			}
#line 2973 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 47:
#line 556 "parse.y" /* yacc.c:1648  */
    {
			// We interpret this as an empty record constructor.
			(yyval.expr) = new RecordConstructorExpr(new ListExpr);
			}
#line 2982 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 48:
#line 563 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new RecordConstructorExpr((yyvsp[-1].list));
			}
#line 2991 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 49:
#line 568 "parse.y" /* yacc.c:1648  */
    { ++in_init; }
#line 2997 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 50:
#line 568 "parse.y" /* yacc.c:1648  */
    { --in_init; }
#line 3003 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 51:
#line 570 "parse.y" /* yacc.c:1648  */
    { // the ++in_init fixes up the parsing of "[x] = y"
			set_location((yylsp[-6]), (yylsp[-2]));
			(yyval.expr) = new TableConstructorExpr((yyvsp[-3].list), (yyvsp[0].attr_l));
			}
#line 3012 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 52:
#line 576 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.expr) = new SetConstructorExpr((yyvsp[-2].list), (yyvsp[0].attr_l));
			}
#line 3021 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 53:
#line 582 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new VectorConstructorExpr((yyvsp[-1].list));
			}
#line 3030 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 54:
#line 588 "parse.y" /* yacc.c:1648  */
    {
			if ( expr_is_table_type_name((yyvsp[-1].expr)) )
				++in_init;
			}
#line 3039 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 55:
#line 594 "parse.y" /* yacc.c:1648  */
    {
			if ( expr_is_table_type_name((yyvsp[-3].expr)) )
				--in_init;
			}
#line 3048 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 56:
#line 600 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-5]), (yylsp[0]));

			BroType* ctor_type = 0;

			if ( (yyvsp[-5].expr)->Tag() == EXPR_NAME &&
			     (ctor_type = (yyvsp[-5].expr)->AsNameExpr()->Id()->AsType()) )
				{
				switch ( ctor_type->Tag() ) {
				case TYPE_RECORD:
					(yyval.expr) = new RecordCoerceExpr(new RecordConstructorExpr((yyvsp[-2].list)),
					                          ctor_type->AsRecordType());
					break;

				case TYPE_TABLE:
					if ( ctor_type->IsTable() )
						(yyval.expr) = new TableConstructorExpr((yyvsp[-2].list), 0, ctor_type);
					else
						(yyval.expr) = new SetConstructorExpr((yyvsp[-2].list), 0, ctor_type);

					break;

				case TYPE_VECTOR:
					(yyval.expr) = new VectorConstructorExpr((yyvsp[-2].list), ctor_type);
					break;

				default:
					(yyvsp[-5].expr)->Error("constructor type not implemented");
					YYERROR;
				}
				}

			else
				(yyval.expr) = new CallExpr((yyvsp[-5].expr), (yyvsp[-2].list), in_hook > 0);
			}
#line 3088 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 57:
#line 636 "parse.y" /* yacc.c:1648  */
    { ++in_hook; }
#line 3094 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 58:
#line 637 "parse.y" /* yacc.c:1648  */
    {
			--in_hook;
			set_location((yylsp[-2]), (yylsp[0]));
			if ( (yyvsp[0].expr)->Tag() != EXPR_CALL )
				(yyvsp[0].expr)->Error("not a valid hook call expression");
			(yyval.expr) = (yyvsp[0].expr);
			}
#line 3106 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 59:
#line 646 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new HasFieldExpr((yyvsp[-2].expr), (yyvsp[0].str));
			}
#line 3115 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 61:
#line 654 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new ScheduleExpr((yyvsp[-3].expr), (yyvsp[-1].event_expr));
			}
#line 3124 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 62:
#line 660 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[0]));

			ID* id = lookup_ID((yyvsp[0].str), current_module.c_str());
			if ( ! id )
				{
				if ( ! in_debug )
					{
/*	// CHECK THAT THIS IS NOT GLOBAL.
					id = install_ID($1, current_module.c_str(),
							false, is_export);
*/

					yyerror(fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				else
					{
					yyerror(fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				}
			else
				{
				if ( ! id->Type() )
					{
					id->Error("undeclared variable");
					id->SetType(error_type());
					(yyval.expr) = new NameExpr(id);
					}

				else if ( id->IsEnumConst() )
					{
					EnumType* t = id->Type()->AsEnumType();
					int intval = t->Lookup(id->ModuleName(),
							       id->Name());
					if ( intval < 0 )
						reporter->InternalError("enum value not found for %s", id->Name());
					(yyval.expr) = new ConstExpr(new EnumVal(intval, t));
					}
				else
					(yyval.expr) = new NameExpr(id);

				if ( id->IsDeprecated() )
					reporter->Warning("deprecated (%s)", id->Name());
				}
			}
#line 3176 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 63:
#line 709 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[0]));
			(yyval.expr) = new ConstExpr((yyvsp[0].val));
			}
#line 3185 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 64:
#line 714 "parse.y" /* yacc.c:1648  */
    { begin_RE(); }
#line 3191 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 65:
#line 715 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-1]));

			RE_Matcher* re = new RE_Matcher((yyvsp[-1].str));
			delete [] (yyvsp[-1].str);

			if ( (yyvsp[0].b) )
				re->MakeCaseInsensitive();

			re->Compile();
			(yyval.expr) = new ConstExpr(new PatternVal(re));
			}
#line 3208 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 66:
#line 729 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new SizeExpr((yyvsp[-1].expr));
			}
#line 3217 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 67:
#line 735 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new CastExpr((yyvsp[-2].expr), (yyvsp[0].type));
			}
#line 3226 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 68:
#line 741 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new IsExpr((yyvsp[-2].expr), (yyvsp[0].type));
			}
#line 3235 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 69:
#line 749 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyvsp[-2].list)->Append((yyvsp[0].expr));
			}
#line 3244 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 70:
#line 755 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[0]));
			(yyval.list) = new ListExpr((yyvsp[0].expr));
			}
#line 3253 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 72:
#line 764 "parse.y" /* yacc.c:1648  */
    { (yyval.list) = new ListExpr(); }
#line 3259 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 73:
#line 769 "parse.y" /* yacc.c:1648  */
    {
			(yyval.type) = cur_enum_type;
			cur_enum_type = NULL;
			}
#line 3268 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 74:
#line 775 "parse.y" /* yacc.c:1648  */
    {
			(yyval.type) = cur_enum_type;
			cur_enum_type = NULL;
			}
#line 3277 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 77:
#line 794 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			assert(cur_enum_type);

			if ( (yyvsp[-1].val)->Type()->Tag() != TYPE_COUNT )
				reporter->Error("enumerator is not a count constant");
			else
				cur_enum_type->AddName(current_module, (yyvsp[-3].str),
				                       (yyvsp[-1].val)->InternalUnsigned(), is_export, (yyvsp[0].b));
			}
#line 3292 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 78:
#line 806 "parse.y" /* yacc.c:1648  */
    {
			/* We only accept counts as enumerator, but we want to return a nice
			   error message if users triy to use a negative integer (will also
			   catch other cases, but that's fine.)
			*/
			reporter->Error("enumerator is not a count constant");
			}
#line 3304 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 79:
#line 815 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-1]));
			assert(cur_enum_type);
			cur_enum_type->AddName(current_module, (yyvsp[-1].str), is_export, (yyvsp[0].b));
			}
#line 3314 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 80:
#line 823 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_BOOL);
				}
#line 3323 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 81:
#line 828 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INT);
				}
#line 3332 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 82:
#line 833 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_COUNT);
				}
#line 3341 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 83:
#line 838 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_COUNTER);
				}
#line 3350 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 84:
#line 843 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_DOUBLE);
				}
#line 3359 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 85:
#line 848 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_TIME);
				}
#line 3368 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 86:
#line 853 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INTERVAL);
				}
#line 3377 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 87:
#line 858 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_STRING);
				}
#line 3386 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 88:
#line 863 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PATTERN);
				}
#line 3395 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 89:
#line 868 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_TIMER);
				}
#line 3404 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 90:
#line 873 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PORT);
				}
#line 3413 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 91:
#line 878 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ADDR);
				}
#line 3422 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 92:
#line 883 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_SUBNET);
				}
#line 3431 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 93:
#line 888 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ANY);
				}
#line 3440 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 94:
#line 894 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[-5]), (yylsp[0]));
				(yyval.type) = new TableType((yyvsp[-3].type_l), (yyvsp[0].type));
				}
#line 3449 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 95:
#line 900 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[-3]), (yylsp[0]));
				(yyval.type) = new SetType((yyvsp[-1].type_l), 0);
				}
#line 3458 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 96:
#line 906 "parse.y" /* yacc.c:1648  */
    { ++in_record; }
#line 3464 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 97:
#line 908 "parse.y" /* yacc.c:1648  */
    { --in_record; }
#line 3470 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 98:
#line 910 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[-5]), (yylsp[-1]));
				(yyval.type) = new RecordType((yyvsp[-2].type_decl_l));
				}
#line 3479 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 99:
#line 916 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[-3]), (yylsp[0]));
				reporter->Error("union type not implemented");
				(yyval.type) = 0;
				}
#line 3489 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 100:
#line 922 "parse.y" /* yacc.c:1648  */
    { set_location((yylsp[-1])); parser_new_enum(); }
#line 3495 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 101:
#line 923 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[-4]), (yylsp[0]));
				(yyvsp[-1].type)->UpdateLocationEndInfo((yylsp[0]));
				(yyval.type) = (yyvsp[-1].type);
				}
#line 3505 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 102:
#line 930 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				// $$ = new TypeList();
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3516 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 103:
#line 938 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[-2]));
				// $$ = new TypeList($3);
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3527 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 104:
#line 946 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new VectorType((yyvsp[0].type));
				}
#line 3536 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 105:
#line 952 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[-1]), (yylsp[0]));
				(yyval.type) = (yyvsp[0].func_type);
				}
#line 3545 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 106:
#line 958 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType((yyvsp[-1].record), 0, FUNC_FLAVOR_EVENT);
				}
#line 3554 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 107:
#line 964 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType((yyvsp[-1].record), base_type(TYPE_BOOL), FUNC_FLAVOR_HOOK);
				}
#line 3563 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 108:
#line 970 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new FileType((yyvsp[0].type));
				}
#line 3572 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 109:
#line 976 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[0]));
				(yyval.type) = new FileType(base_type(TYPE_STRING));
				}
#line 3581 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 110:
#line 982 "parse.y" /* yacc.c:1648  */
    {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new OpaqueType((yyvsp[0].str));
				}
#line 3590 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 111:
#line 988 "parse.y" /* yacc.c:1648  */
    {
			if ( ! (yyvsp[0].id) || ! ((yyval.type) = (yyvsp[0].id)->AsType()) )
				{
				NullStmt here;
				if ( (yyvsp[0].id) )
					(yyvsp[0].id)->Error("not a Bro type", &here);
				(yyval.type) = error_type();
				}
			else
				{
				Ref((yyval.type));

				if ( (yyvsp[0].id)->IsDeprecated() )
					reporter->Warning("deprecated (%s)", (yyvsp[0].id)->Name());
				}
			}
#line 3611 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 112:
#line 1008 "parse.y" /* yacc.c:1648  */
    { (yyvsp[-2].type_l)->AppendEvenIfNotPure((yyvsp[0].type)); }
#line 3617 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 113:
#line 1010 "parse.y" /* yacc.c:1648  */
    {
			(yyval.type_l) = new TypeList((yyvsp[0].type));
			(yyval.type_l)->Append((yyvsp[0].type));
			}
#line 3626 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 114:
#line 1018 "parse.y" /* yacc.c:1648  */
    {
			(yyvsp[-1].type_decl_l)->append((yyvsp[0].type_decl));
			}
#line 3634 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 115:
#line 1022 "parse.y" /* yacc.c:1648  */
    {
			(yyval.type_decl_l) = new type_decl_list();
			}
#line 3642 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 116:
#line 1029 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.type_decl) = new TypeDecl((yyvsp[-2].type), (yyvsp[-4].str), (yyvsp[-1].attr_l), (in_record > 0));

			if ( in_record > 0 && cur_decl_type_id )
				broxygen_mgr->RecordField(cur_decl_type_id, (yyval.type_decl), ::filename);
			}
#line 3654 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 117:
#line 1040 "parse.y" /* yacc.c:1648  */
    { (yyval.record) = new RecordType((yyvsp[0].type_decl_l)); }
#line 3660 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 118:
#line 1042 "parse.y" /* yacc.c:1648  */
    { (yyval.record) = new RecordType((yyvsp[-1].type_decl_l)); }
#line 3666 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 119:
#line 1044 "parse.y" /* yacc.c:1648  */
    { (yyval.record) = new RecordType(new type_decl_list()); }
#line 3672 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 120:
#line 1049 "parse.y" /* yacc.c:1648  */
    { (yyvsp[-2].type_decl_l)->append((yyvsp[0].type_decl)); }
#line 3678 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 121:
#line 1051 "parse.y" /* yacc.c:1648  */
    { (yyvsp[-2].type_decl_l)->append((yyvsp[0].type_decl)); }
#line 3684 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 122:
#line 1053 "parse.y" /* yacc.c:1648  */
    { (yyval.type_decl_l) = new type_decl_list(); (yyval.type_decl_l)->append((yyvsp[0].type_decl)); }
#line 3690 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 123:
#line 1058 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.type_decl) = new TypeDecl((yyvsp[-1].type), (yyvsp[-3].str), (yyvsp[0].attr_l));
			}
#line 3699 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 124:
#line 1066 "parse.y" /* yacc.c:1648  */
    {
			current_module = (yyvsp[-1].str);
			broxygen_mgr->ModuleUsage(::filename, current_module);
			}
#line 3708 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 125:
#line 1071 "parse.y" /* yacc.c:1648  */
    { is_export = true; }
#line 3714 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 126:
#line 1072 "parse.y" /* yacc.c:1648  */
    { is_export = false; }
#line 3720 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 127:
#line 1075 "parse.y" /* yacc.c:1648  */
    {
			add_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REGULAR);
			broxygen_mgr->Identifier((yyvsp[-5].id));
			}
#line 3729 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 128:
#line 1081 "parse.y" /* yacc.c:1648  */
    {
			add_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_OPTION);
			broxygen_mgr->Identifier((yyvsp[-5].id));
			}
#line 3738 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 129:
#line 1087 "parse.y" /* yacc.c:1648  */
    {
			add_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_CONST);
			broxygen_mgr->Identifier((yyvsp[-5].id));
			}
#line 3747 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 130:
#line 1093 "parse.y" /* yacc.c:1648  */
    {
			add_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REDEF);
			broxygen_mgr->Redef((yyvsp[-5].id), ::filename);
			}
#line 3756 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 131:
#line 1099 "parse.y" /* yacc.c:1648  */
    { parser_redef_enum((yyvsp[-2].id)); broxygen_mgr->Redef((yyvsp[-2].id), ::filename); }
#line 3762 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 132:
#line 1101 "parse.y" /* yacc.c:1648  */
    {
			// Broxygen already grabbed new enum IDs as the type created them.
			}
#line 3770 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 133:
#line 1106 "parse.y" /* yacc.c:1648  */
    { cur_decl_type_id = (yyvsp[0].id); broxygen_mgr->Redef((yyvsp[0].id), ::filename); }
#line 3776 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 134:
#line 1108 "parse.y" /* yacc.c:1648  */
    { ++in_record; }
#line 3782 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 135:
#line 1110 "parse.y" /* yacc.c:1648  */
    { --in_record; }
#line 3788 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 136:
#line 1112 "parse.y" /* yacc.c:1648  */
    {
			cur_decl_type_id = 0;

			if ( ! (yyvsp[-9].id)->Type() )
				(yyvsp[-9].id)->Error("unknown identifier");
			else
				extend_record((yyvsp[-9].id), (yyvsp[-4].type_decl_l), (yyvsp[-1].attr_l));
			}
#line 3801 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 137:
#line 1122 "parse.y" /* yacc.c:1648  */
    { cur_decl_type_id = (yyvsp[-1].id); broxygen_mgr->StartType((yyvsp[-1].id));  }
#line 3807 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 138:
#line 1124 "parse.y" /* yacc.c:1648  */
    {
			cur_decl_type_id = 0;
			add_type((yyvsp[-5].id), (yyvsp[-2].type), (yyvsp[-1].attr_l));
			broxygen_mgr->Identifier((yyvsp[-5].id));
			}
#line 3817 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 139:
#line 1131 "parse.y" /* yacc.c:1648  */
    { }
#line 3823 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 140:
#line 1134 "parse.y" /* yacc.c:1648  */
    { }
#line 3829 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 144:
#line 1145 "parse.y" /* yacc.c:1648  */
    { do_atif((yyvsp[-1].expr)); }
#line 3835 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 145:
#line 1147 "parse.y" /* yacc.c:1648  */
    { do_atifdef((yyvsp[-1].str)); }
#line 3841 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 146:
#line 1149 "parse.y" /* yacc.c:1648  */
    { do_atifndef((yyvsp[-1].str)); }
#line 3847 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 147:
#line 1151 "parse.y" /* yacc.c:1648  */
    { do_atendif(); }
#line 3853 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 148:
#line 1153 "parse.y" /* yacc.c:1648  */
    { do_atelse(); }
#line 3859 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 149:
#line 1158 "parse.y" /* yacc.c:1648  */
    {
			begin_func((yyvsp[-2].id), current_module.c_str(),
				FUNC_FLAVOR_FUNCTION, 0, (yyvsp[-1].func_type), (yyvsp[0].attr_l));
			(yyval.func_type) = (yyvsp[-1].func_type);
			broxygen_mgr->Identifier((yyvsp[-2].id));
			}
#line 3870 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 150:
#line 1165 "parse.y" /* yacc.c:1648  */
    {
			begin_func((yyvsp[-2].id), current_module.c_str(),
				   FUNC_FLAVOR_EVENT, 0, (yyvsp[-1].func_type), (yyvsp[0].attr_l));
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 3880 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 151:
#line 1171 "parse.y" /* yacc.c:1648  */
    {
			(yyvsp[-1].func_type)->ClearYieldType(FUNC_FLAVOR_HOOK);
			(yyvsp[-1].func_type)->SetYieldType(base_type(TYPE_BOOL));
			begin_func((yyvsp[-2].id), current_module.c_str(),
				   FUNC_FLAVOR_HOOK, 0, (yyvsp[-1].func_type), (yyvsp[0].attr_l));
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 3892 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 152:
#line 1179 "parse.y" /* yacc.c:1648  */
    {
			begin_func((yyvsp[-2].id), current_module.c_str(),
				   FUNC_FLAVOR_EVENT, 1, (yyvsp[-1].func_type), (yyvsp[0].attr_l));
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 3902 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 153:
#line 1188 "parse.y" /* yacc.c:1648  */
    {
			saved_in_init.push_back(in_init);
			in_init = 0;
			}
#line 3911 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 154:
#line 1194 "parse.y" /* yacc.c:1648  */
    {
			in_init = saved_in_init.back();
			saved_in_init.pop_back();
			}
#line 3920 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 155:
#line 1200 "parse.y" /* yacc.c:1648  */
    {
			end_func((yyvsp[-2].stmt));
			}
#line 3928 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 156:
#line 1207 "parse.y" /* yacc.c:1648  */
    { (yyval.expr) = new ConstExpr((yyvsp[-1].id)->ID_Val()); }
#line 3934 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 157:
#line 1212 "parse.y" /* yacc.c:1648  */
    {
			(yyval.id) = current_scope()->GenerateTemporary("anonymous-function");
			begin_func((yyval.id), current_module.c_str(),
				   FUNC_FLAVOR_FUNCTION, 0, (yyvsp[0].func_type));
			}
#line 3944 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 158:
#line 1221 "parse.y" /* yacc.c:1648  */
    { (yyval.func_type) = new FuncType((yyvsp[-3].record), (yyvsp[0].type), FUNC_FLAVOR_FUNCTION); }
#line 3950 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 159:
#line 1223 "parse.y" /* yacc.c:1648  */
    { (yyval.func_type) = new FuncType((yyvsp[-1].record), base_type(TYPE_VOID), FUNC_FLAVOR_FUNCTION); }
#line 3956 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 160:
#line 1228 "parse.y" /* yacc.c:1648  */
    { (yyval.type) = (yyvsp[0].type); }
#line 3962 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 161:
#line 1230 "parse.y" /* yacc.c:1648  */
    { (yyval.type) = 0; }
#line 3968 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 162:
#line 1234 "parse.y" /* yacc.c:1648  */
    { (yyval.ic) = INIT_NONE; }
#line 3974 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 163:
#line 1235 "parse.y" /* yacc.c:1648  */
    { (yyval.ic) = INIT_FULL; }
#line 3980 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 164:
#line 1236 "parse.y" /* yacc.c:1648  */
    { (yyval.ic) = INIT_EXTRA; }
#line 3986 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 165:
#line 1237 "parse.y" /* yacc.c:1648  */
    { (yyval.ic) = INIT_REMOVE; }
#line 3992 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 166:
#line 1241 "parse.y" /* yacc.c:1648  */
    { ++in_init; }
#line 3998 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 167:
#line 1241 "parse.y" /* yacc.c:1648  */
    { --in_init; }
#line 4004 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 168:
#line 1242 "parse.y" /* yacc.c:1648  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 4010 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 169:
#line 1244 "parse.y" /* yacc.c:1648  */
    { (yyval.expr) = 0; }
#line 4016 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 170:
#line 1249 "parse.y" /* yacc.c:1648  */
    { (yyval.expr) = (yyvsp[-1].list); }
#line 4022 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 171:
#line 1251 "parse.y" /* yacc.c:1648  */
    { (yyval.expr) = (yyvsp[-2].list); }
#line 4028 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 174:
#line 1258 "parse.y" /* yacc.c:1648  */
    { (yyval.attr_l) = 0; }
#line 4034 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 175:
#line 1263 "parse.y" /* yacc.c:1648  */
    { (yyvsp[-1].attr_l)->append((yyvsp[0].attr)); }
#line 4040 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 176:
#line 1265 "parse.y" /* yacc.c:1648  */
    {
			(yyval.attr_l) = new attr_list;
			(yyval.attr_l)->append((yyvsp[0].attr));
			}
#line 4049 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 177:
#line 1273 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_DEFAULT, (yyvsp[0].expr)); }
#line 4055 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 178:
#line 1275 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_OPTIONAL); }
#line 4061 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 179:
#line 1277 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_REDEF); }
#line 4067 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 180:
#line 1279 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_ROTATE_INTERVAL, (yyvsp[0].expr)); }
#line 4073 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 181:
#line 1281 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_ROTATE_SIZE, (yyvsp[0].expr)); }
#line 4079 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 182:
#line 1283 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_ADD_FUNC, (yyvsp[0].expr)); }
#line 4085 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 183:
#line 1285 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_DEL_FUNC, (yyvsp[0].expr)); }
#line 4091 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 184:
#line 1287 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_FUNC, (yyvsp[0].expr)); }
#line 4097 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 185:
#line 1289 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_CREATE, (yyvsp[0].expr)); }
#line 4103 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 186:
#line 1291 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_READ, (yyvsp[0].expr)); }
#line 4109 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 187:
#line 1293 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_WRITE, (yyvsp[0].expr)); }
#line 4115 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 188:
#line 1295 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_PERSISTENT); }
#line 4121 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 189:
#line 1297 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_SYNCHRONIZED); }
#line 4127 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 190:
#line 1299 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_ENCRYPT); }
#line 4133 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 191:
#line 1301 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_ENCRYPT, (yyvsp[0].expr)); }
#line 4139 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 192:
#line 1303 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_RAW_OUTPUT); }
#line 4145 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 193:
#line 1305 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_MERGEABLE); }
#line 4151 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 194:
#line 1307 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_PRIORITY, (yyvsp[0].expr)); }
#line 4157 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 195:
#line 1309 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_TYPE_COLUMN, (yyvsp[0].expr)); }
#line 4163 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 196:
#line 1311 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_LOG); }
#line 4169 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 197:
#line 1313 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_ERROR_HANDLER); }
#line 4175 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 198:
#line 1315 "parse.y" /* yacc.c:1648  */
    { (yyval.attr) = new Attr(ATTR_DEPRECATED); }
#line 4181 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 199:
#line 1320 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.stmt) = (yyvsp[-1].stmt);
			if ( (yyvsp[-2].b) )
			    brofiler.DecIgnoreDepth();
			}
#line 4192 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 200:
#line 1328 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new PrintStmt((yyvsp[-2].list));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4203 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 201:
#line 1336 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new EventStmt((yyvsp[-2].event_expr));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4214 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 202:
#line 1344 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), new NullStmt());
			}
#line 4223 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 203:
#line 1350 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-6]), (yylsp[-3]));
			(yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt));
			}
#line 4232 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 204:
#line 1356 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-4]), (yylsp[-3]));
			(yyval.stmt) = new SwitchStmt((yyvsp[-3].expr), (yyvsp[-1].case_l));
			}
#line 4241 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 205:
#line 1362 "parse.y" /* yacc.c:1648  */
    {
			(yyvsp[-1].stmt)->AsForStmt()->AddBody((yyvsp[0].stmt));
			}
#line 4249 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 206:
#line 1367 "parse.y" /* yacc.c:1648  */
    {
			(yyval.stmt) = new WhileStmt((yyvsp[-2].expr), (yyvsp[0].stmt));
			}
#line 4257 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 207:
#line 1372 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new NextStmt;
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4268 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 208:
#line 1380 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new BreakStmt;
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4279 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 209:
#line 1388 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new FallthroughStmt;
			if ( ! (yyvsp[0].b) )
				brofiler.AddStmt((yyval.stmt));
			}
#line 4290 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 210:
#line 1396 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ReturnStmt(0);
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4301 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 211:
#line 1404 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-3]), (yylsp[-2]));
			(yyval.stmt) = new ReturnStmt((yyvsp[-2].expr));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4312 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 212:
#line 1412 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new AddStmt((yyvsp[-2].expr));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4323 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 213:
#line 1420 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new DelStmt((yyvsp[-2].expr));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4334 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 214:
#line 1428 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-7]), (yylsp[-1]));
			(yyval.stmt) = add_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_REGULAR);
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4345 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 215:
#line 1436 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-7]), (yylsp[-2]));
			(yyval.stmt) = add_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_CONST);
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4356 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 216:
#line 1444 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.stmt) = new WhenStmt((yyvsp[-2].expr), (yyvsp[0].stmt), 0, 0, false);
			}
#line 4365 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 217:
#line 1450 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-8]), (yylsp[-2]));
			(yyval.stmt) = new WhenStmt((yyvsp[-8].expr), (yyvsp[-6].stmt), (yyvsp[-1].stmt), (yyvsp[-4].expr), false);
			if ( (yyvsp[-2].b) )
			    brofiler.DecIgnoreDepth();
			}
#line 4376 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 218:
#line 1459 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.stmt) = new WhenStmt((yyvsp[-2].expr), (yyvsp[0].stmt), 0, 0, true);
			}
#line 4385 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 219:
#line 1465 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-8]), (yylsp[-2]));
			(yyval.stmt) = new WhenStmt((yyvsp[-8].expr), (yyvsp[-6].stmt), (yyvsp[-1].stmt), (yyvsp[-4].expr), true);
			if ( (yyvsp[-2].b) )
			    brofiler.DecIgnoreDepth();
			}
#line 4396 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 220:
#line 1473 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ExprStmt((yyvsp[-2].expr));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4407 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 221:
#line 1481 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[0]), (yylsp[0]));
			(yyval.stmt) = new NullStmt;
			}
#line 4416 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 222:
#line 1487 "parse.y" /* yacc.c:1648  */
    { (yyval.stmt) = new NullStmt; }
#line 4422 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 223:
#line 1492 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyvsp[-1].stmt)->AsStmtList()->Stmts().append((yyvsp[0].stmt));
			(yyvsp[-1].stmt)->UpdateLocationEndInfo((yylsp[0]));
			}
#line 4432 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 224:
#line 1498 "parse.y" /* yacc.c:1648  */
    { (yyval.stmt) = new StmtList(); }
#line 4438 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 225:
#line 1503 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-3]), (yylsp[0]));

			ID* id = lookup_ID((yyvsp[-3].str), current_module.c_str());
			if ( id )
				{
				if ( ! id->IsGlobal() )
					{
					yyerror(fmt("local identifier \"%s\" cannot be used to reference an event", (yyvsp[-3].str)));
					YYERROR;
					}
				if ( id->IsDeprecated() )
					reporter->Warning("deprecated (%s)", id->Name());
				}

			(yyval.event_expr) = new EventExpr((yyvsp[-3].str), (yyvsp[-1].list));
			}
#line 4460 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 226:
#line 1524 "parse.y" /* yacc.c:1648  */
    { (yyvsp[-1].case_l)->append((yyvsp[0].c_case)); }
#line 4466 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 227:
#line 1526 "parse.y" /* yacc.c:1648  */
    { (yyval.case_l) = new case_list; }
#line 4472 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 228:
#line 1531 "parse.y" /* yacc.c:1648  */
    { (yyval.c_case) = new Case((yyvsp[-2].list), 0, (yyvsp[0].stmt)); }
#line 4478 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 229:
#line 1534 "parse.y" /* yacc.c:1648  */
    { (yyval.c_case) = new Case(0, (yyvsp[-2].id_l), (yyvsp[0].stmt)); }
#line 4484 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 230:
#line 1537 "parse.y" /* yacc.c:1648  */
    { (yyval.c_case) = new Case(0, 0, (yyvsp[0].stmt)); }
#line 4490 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 231:
#line 1542 "parse.y" /* yacc.c:1648  */
    { (yyvsp[-2].id_l)->append((yyvsp[0].id)); }
#line 4496 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 232:
#line 1545 "parse.y" /* yacc.c:1648  */
    {
			(yyval.id_l) = new id_list;
			(yyval.id_l)->append((yyvsp[0].id));
			}
#line 4505 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 233:
#line 1553 "parse.y" /* yacc.c:1648  */
    {
			(yyval.id) = new ID(0, SCOPE_FUNCTION, 0);
			(yyval.id)->SetType((yyvsp[0].type));
			}
#line 4514 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 234:
#line 1559 "parse.y" /* yacc.c:1648  */
    {
			const char* name = (yyvsp[0].str);
			BroType* type = (yyvsp[-2].type);
			ID* case_var = lookup_ID(name, current_module.c_str());

			if ( case_var && case_var->IsGlobal() )
				case_var->Error("already a global identifier");
			else
				case_var = install_ID(name, current_module.c_str(), false, false);

			add_local(case_var, type, INIT_NONE, 0, 0, VAR_REGULAR);
			(yyval.id) = case_var;
			}
#line 4532 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 235:
#line 1575 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[-5]), (yylsp[0]));

			// This rule needs to be separate from the loop
			// body so that we execute these actions - defining
			// the local variable - prior to parsing the body,
			// which might refer to the variable.
			ID* loop_var = lookup_ID((yyvsp[-3].str), current_module.c_str());

			if ( loop_var )
				{
				if ( loop_var->IsGlobal() )
					loop_var->Error("global used in for loop");
				}

			else
				loop_var = install_ID((yyvsp[-3].str), current_module.c_str(),
						      false, false);

			id_list* loop_vars = new id_list;
			loop_vars->append(loop_var);

			(yyval.stmt) = new ForStmt(loop_vars, (yyvsp[-1].expr));
			}
#line 4561 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 236:
#line 1601 "parse.y" /* yacc.c:1648  */
    { (yyval.stmt) = new ForStmt((yyvsp[-4].id_l), (yyvsp[-1].expr)); }
#line 4567 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 237:
#line 1606 "parse.y" /* yacc.c:1648  */
    { (yyvsp[-2].id_l)->append((yyvsp[0].id)); }
#line 4573 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 238:
#line 1608 "parse.y" /* yacc.c:1648  */
    {
			(yyval.id_l) = new id_list;
			(yyval.id_l)->append((yyvsp[0].id));
			}
#line 4582 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 239:
#line 1616 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[0]));

			(yyval.id) = lookup_ID((yyvsp[0].str), current_module.c_str());
			if ( (yyval.id) )
				{
				if ( (yyval.id)->IsGlobal() )
					(yyval.id)->Error("already a global identifier");
				delete [] (yyvsp[0].str);
				}

			else
				{
				(yyval.id) = install_ID((yyvsp[0].str), current_module.c_str(),
						false, is_export);
				}
			}
#line 4604 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 240:
#line 1636 "parse.y" /* yacc.c:1648  */
    { resolving_global_ID = 1; }
#line 4610 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 241:
#line 1637 "parse.y" /* yacc.c:1648  */
    { (yyval.id) = (yyvsp[0].id); }
#line 4616 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 242:
#line 1641 "parse.y" /* yacc.c:1648  */
    { defining_global_ID = 1; }
#line 4622 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 243:
#line 1641 "parse.y" /* yacc.c:1648  */
    { defining_global_ID = 0; }
#line 4628 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 244:
#line 1642 "parse.y" /* yacc.c:1648  */
    { (yyval.id) = (yyvsp[-1].id); }
#line 4634 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 245:
#line 1646 "parse.y" /* yacc.c:1648  */
    { resolving_global_ID = 0; }
#line 4640 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 246:
#line 1647 "parse.y" /* yacc.c:1648  */
    { (yyval.id) = (yyvsp[0].id); }
#line 4646 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 247:
#line 1652 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[0]));

			(yyval.id) = lookup_ID((yyvsp[0].str), current_module.c_str(), false, defining_global_ID);
			if ( (yyval.id) )
				{
				if ( ! (yyval.id)->IsGlobal() )
					(yyval.id)->Error("already a local identifier");

				if ( (yyval.id)->IsDeprecated() )
					{
					BroType* t = (yyval.id)->Type();

					if ( t->Tag() != TYPE_FUNC ||
					     t->AsFuncType()->Flavor() != FUNC_FLAVOR_FUNCTION )
						reporter->Warning("deprecated (%s)", (yyval.id)->Name());
					}

				delete [] (yyvsp[0].str);
				}

			else
				{
				const char* module_name =
					resolving_global_ID ?
						current_module.c_str() : 0;

				(yyval.id) = install_ID((yyvsp[0].str), module_name,
						true, is_export);
				}
			}
#line 4682 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 248:
#line 1688 "parse.y" /* yacc.c:1648  */
    {
			set_location((yylsp[0]));
			(yyval.id) = lookup_ID((yyvsp[0].str), current_module.c_str());

			if ( ! (yyval.id) )
				reporter->Error("identifier not defined: %s", (yyvsp[0].str));

			delete [] (yyvsp[0].str);
			}
#line 4696 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 249:
#line 1701 "parse.y" /* yacc.c:1648  */
    { (yyval.b) = true; }
#line 4702 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 250:
#line 1703 "parse.y" /* yacc.c:1648  */
    { (yyval.b) = false; }
#line 4708 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 251:
#line 1707 "parse.y" /* yacc.c:1648  */
    { (yyval.b) = true; brofiler.IncIgnoreDepth(); }
#line 4714 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 252:
#line 1709 "parse.y" /* yacc.c:1648  */
    { (yyval.b) = false; }
#line 4720 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 253:
#line 1713 "parse.y" /* yacc.c:1648  */
    { (yyval.b) = true; }
#line 4726 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;

  case 254:
#line 1715 "parse.y" /* yacc.c:1648  */
    { (yyval.b) = false; }
#line 4732 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
    break;


#line 4736 "/usr/src/RPM/BUILD/bro-2.6/build/src/p.cc" /* yacc.c:1648  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1717 "parse.y" /* yacc.c:1907  */


int yyerror(const char msg[])
	{
	char* msgbuf = new char[strlen(msg) + strlen(last_tok) + 128];

	if ( last_tok[0] == '\n' )
		sprintf(msgbuf, "%s, on previous line", msg);
	else if ( last_tok[0] == '\0' )
		sprintf(msgbuf, "%s, at end of file", msg);
	else
		sprintf(msgbuf, "%s, at or near \"%s\"", msg, last_tok);

	if ( in_debug )
		g_curr_debug_error = copy_string(msg);

	reporter->Error("%s", msgbuf);

	return 0;
	}
